searchNodes=[{"doc":"","ref":"Chi2fit.CSV.html","title":"Chi2fit.CSV","type":"module"},{"doc":"Reads CSV data, extracts one column, and returns it as a list of NaiveDateTime . Examples iex&gt; csv = [ &quot;Done&quot; , &quot;2019/05/01&quot; , &quot;2019/06/01&quot; ] |&gt; Stream . map ( &amp; &amp;1 ) ...&gt; csv_to_list csv , &quot;Done&quot; , header? : true [ ~N[2019-06-01 00:00:00] , ~N[2019-05-01 00:00:00] ] iex&gt; csv = [ &quot;Done&quot; , &quot;2019/May/01&quot; , &quot;2019/Jun/01&quot; ] |&gt; Stream . map ( &amp; &amp;1 ) ...&gt; csv_to_list csv , &quot;Done&quot; , header? : true , format : &quot;{YYYY}/{Mshort}/{0D}&quot; [ ~N[2019-06-01 00:00:00] , ~N[2019-05-01 00:00:00] ] iex&gt; csv = [ &quot;Done&quot; , &quot;2019/May/01&quot; , &quot;2019/06/01&quot; ] |&gt; Stream . map ( &amp; &amp;1 ) ...&gt; csv_to_list csv , &quot;Done&quot; , header? : true , format : &quot;{YYYY}/{Mshort}/{0D}&quot; [ ~N[2019-05-01 00:00:00] ] iex&gt; csv = [ &quot;Done&quot; , &quot;2019/May/01&quot; , &quot;2019/06/01&quot; ] |&gt; Stream . map ( &amp; &amp;1 ) ...&gt; csv_to_list csv , &quot;Done&quot; , header? : true , format : [ &quot;{YYYY}/{Mshort}/{0D}&quot; , &quot;{YYYY}/{0M}/{0D}&quot; ] [ ~N[2019-06-01 00:00:00] , ~N[2019-05-01 00:00:00] ] iex&gt; csv = [ &quot;Done&quot; , &quot;2019/May/01&quot; , &quot;2019/Jun/01&quot; ] |&gt; Stream . map ( &amp; &amp;1 ) ...&gt; csv_to_list csv , &quot;Done&quot; , header? : true , format : [ &quot;%Y/%b/%d&quot; ] , parser : :strftime [ ~N[2019-06-01 00:00:00] , ~N[2019-05-01 00:00:00] ]","ref":"Chi2fit.CSV.html#csv_to_list/3","title":"Chi2fit.CSV.csv_to_list/3","type":"function"},{"doc":"Provides a command line interface for fitting data against a known cumulative distribution function. Tool for fitting particular probability distributions to empirical cumulative distribution functions. Distributions supported are Weibull, Wald (Inverse Gauss), Normal, Exponential, Erlang, and Skewed Exponential. It uses the Chi-squared Pearson statistic as the likelihood function for fitting. This statistic applies to empirical data that is categorial in nature. It provides various options for controlling the fitting procedure and assignment of errors. It supports asymmetrical errors in fitting the data. Basic usage: scanning the surface As described above fitting the parameters is done by minimizing the chi-squared statistic. Usually this is a function of the distribution paremeters. Scanning the surface is a simple way to have an initial guess of the parameters. The following command does a simple scan of the chi-squared surface against data: $ chi2fit data.csv --ranges &#39;[{0.8,1.2},{0.6,1.2}]&#39; --cdf weibull Initial guess: chi2: 1399.3190035059733 pars: [0.800467783803376, 29.98940654419653] errors: {[0.800467783803376, 0.800467783803376], [29.98940654419653, 29.98940654419653]} and the file data.csv is formatted as Lead Time 26 0 105 69 3 36 ... In this form the command will scan or probe the Chi-squared surface for the parameters within the provided range. It returns the found minimum Chi-squared and the parameter values at this minimum. The reported error ranges correspond to a change of Chi-squared of +1. Options available: probes - The number of probes to use for guessing parameter values at initialization progress - Shows progress during 'probing' (shows progress every 1000 probes) c - Mark progress every 100th probe x - Mark progress every 10th probe More options are described below and are available using the option --help . Input data options Several options control how the input data is interpreted. These are: model - determines how errors are assigned to the data points. Possible values include simple|asimple|linear data - instead of using the file for data, use this option to pass a list of data points correction - Estimate of number of events missed in the right tail of the sample An example of specifying data on the command line is: $ chi2fit --ranges &#39;[{0.8,1.2},{0.6,1.2}]&#39; --cdf weibull --data &#39;[2,3,4,5,5,4,4,7]&#39; Distribution options Distributions supported are: Wald, Weibull, Normal, Erlang, Exponential, and SEP (Skewed Exponential: 3 and 4 parameters). For the distributions of SEP (4 parameters), and SEP0 (3 parameters) the following options exist: method - Supported values are 'gauss|gauss2|gaus3|romberg|romberg2|romberg3' Romberg integration supports the options: tolerance - The target precision for Romberg integration itermax - The maximum number of iterations to use in Romberg integration Gauss integration supports the option: npoints - The number of points to use in Gauss integration (4, 8, 16, and 32) Fitting options AFter probing the surface for an initial guess of the parameters, a fine grained search for the optimum can be done by enabling the fit procedure. The algorithm implemented assumes that the initial guess is close enough to the minimum and uses a combination of parameter estimation and Monte Carlo methods. An additional strategy is to use a so-called grid-search by changing only one parameter at a time. It selects the parameters in a round robin fashion. Using Romberg iteration and Newton root finding algorithm the parameter value minimizing chi-squared is determined while kepping the other parameters constant. Then the other parameters are varied. Especially fitting distributions with 3 or more parameters may benefit from this strategy. Options controlling these are: fit - Enables the fine-grained fitting of parameters iterations - Number of iterations to use in the optimizing the Likelihood function grid - Uses a grid search to fit one parameter at a time in a round robin fashion Sometimes the chi-squared surface is not smooth but numerically problematic to get stable. In this case smoothing the surface may help. The next option enables this feature: smoothing - Smoothing of the likelihood function with a Gaussian kernel The fitting procedures uses derivatives (first and second order) to estimate changes in the parameters that will result in a better fit. Derivaties are calculated using Romberg differentiation. The accuracy and maximum number of iterations are controlled by the options: tolerance - The target precision for Romberg integration itermax - The maximum number of iterations to use in Romberg integration Bootstrapping Bootstrapping can be enabled to estimate the errors in the parameters. The supported options are: bootstrap - Enables bootstrapping. Specifies the number of iterations to perform sample - The sample size to use from the empirical distribution Output options These options are useful for printing data for generating charts of the data: print - Outputs the empirical input data with errors included output - Outputs the fitted distribution function values at the data points surface - Outputs the Chi-squared surface to a file smoothing - Smoothing of the likelihood function with a Gaussian kernel General options Options available for scanning, fitting, and bootstrapping: debug - Outputs additional data for debugging purposes&quot; References [1] R.A. Arndt and M.H. MacGregor, Methods in Computational Physics, Vol. 6 (1966) 256-296 [2] Marius M. Nagels, Baryon-Baryon Scattering in a One-Boson-Exchange Potential Mode, PhD. Thesis, Nijmegen University, 1975 [3] Richard A. Arndt and Malcolm H. MacGregor, Determination of the Nucleon-Nucleon Elastic-Scattering Matrix. IV. Comparison of Energy-Dependent and Energy-Independent Phase-Shift Analyses, Physical Review Volume 142, Number 3, January 1966","ref":"Chi2fit.Cli.html","title":"Chi2fit.Cli","type":"module"},{"doc":"","ref":"Chi2fit.Cli.html#main/0","title":"Chi2fit.Cli.main/0","type":"function"},{"doc":"","ref":"Chi2fit.Cli.html#main/1","title":"Chi2fit.Cli.main/1","type":"function"},{"doc":"Implements an agent for collecting data.","ref":"Chi2fit.Collector.html","title":"Chi2fit.Collector","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Chi2fit.Collector.html#child_spec/1","title":"Chi2fit.Collector.child_spec/1","type":"function"},{"doc":"","ref":"Chi2fit.Collector.html#collect/0","title":"Chi2fit.Collector.collect/0","type":"function"},{"doc":"","ref":"Chi2fit.Collector.html#start_link/0","title":"Chi2fit.Collector.start_link/0","type":"function"},{"doc":"","ref":"Chi2fit.Collector.html#stop/0","title":"Chi2fit.Collector.stop/0","type":"function"},{"doc":"","ref":"Chi2fit.Collector.html#value/0","title":"Chi2fit.Collector.value/0","type":"function"},{"doc":"","ref":"Chi2fit.Distribution.html","title":"Chi2fit.Distribution","type":"protocol"},{"doc":"","ref":"Chi2fit.Distribution.html#cdf/1","title":"Chi2fit.Distribution.cdf/1","type":"function"},{"doc":"","ref":"Chi2fit.Distribution.html#kurtosis/1","title":"Chi2fit.Distribution.kurtosis/1","type":"function"},{"doc":"","ref":"Chi2fit.Distribution.html#name/1","title":"Chi2fit.Distribution.name/1","type":"function"},{"doc":"","ref":"Chi2fit.Distribution.html#pdf/1","title":"Chi2fit.Distribution.pdf/1","type":"function"},{"doc":"","ref":"Chi2fit.Distribution.html#random/1","title":"Chi2fit.Distribution.random/1","type":"function"},{"doc":"","ref":"Chi2fit.Distribution.html#size/1","title":"Chi2fit.Distribution.size/1","type":"function"},{"doc":"","ref":"Chi2fit.Distribution.html#skewness/1","title":"Chi2fit.Distribution.skewness/1","type":"function"},{"doc":"","ref":"Chi2fit.Distribution.html#t:t/0","title":"Chi2fit.Distribution.t/0","type":"type"},{"doc":"Provides the Bernoulli distribution.","ref":"Chi2fit.Distribution.Bernoulli.html","title":"Chi2fit.Distribution.Bernoulli","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Bernoulli.html#t:t/0","title":"Chi2fit.Distribution.Bernoulli.t/0","type":"type"},{"doc":"Bimodal distribution.","ref":"Chi2fit.Distribution.BiModal.html","title":"Chi2fit.Distribution.BiModal","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.BiModal.html#t:t/0","title":"Chi2fit.Distribution.BiModal.t/0","type":"type"},{"doc":"Distribution for flipping coins.","ref":"Chi2fit.Distribution.Coin.html","title":"Chi2fit.Distribution.Coin","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Coin.html#t:t/0","title":"Chi2fit.Distribution.Coin.t/0","type":"type"},{"doc":"Distribution for constant numbers.","ref":"Chi2fit.Distribution.Constant.html","title":"Chi2fit.Distribution.Constant","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Constant.html#t:t/0","title":"Chi2fit.Distribution.Constant.t/0","type":"type"},{"doc":"Provides the Dice distribution.","ref":"Chi2fit.Distribution.Dice.html","title":"Chi2fit.Distribution.Dice","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Dice.html#t:t/0","title":"Chi2fit.Distribution.Dice.t/0","type":"type"},{"doc":"The Erlang distribution.","ref":"Chi2fit.Distribution.Erlang.html","title":"Chi2fit.Distribution.Erlang","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Erlang.html#t:t/0","title":"Chi2fit.Distribution.Erlang.t/0","type":"type"},{"doc":"The exponential distribution.","ref":"Chi2fit.Distribution.Exponential.html","title":"Chi2fit.Distribution.Exponential","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Exponential.html#t:t/0","title":"Chi2fit.Distribution.Exponential.t/0","type":"type"},{"doc":"The Fréchet distribution, also known inverse Weibull distribution.","ref":"Chi2fit.Distribution.Frechet.html","title":"Chi2fit.Distribution.Frechet","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Frechet.html#t:t/0","title":"Chi2fit.Distribution.Frechet.t/0","type":"type"},{"doc":"Bimodal distribution.","ref":"Chi2fit.Distribution.MultiModal.html","title":"Chi2fit.Distribution.MultiModal","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.MultiModal.html#weights/1","title":"Chi2fit.Distribution.MultiModal.weights/1","type":"function"},{"doc":"","ref":"Chi2fit.Distribution.MultiModal.html#t:t/0","title":"Chi2fit.Distribution.MultiModal.t/0","type":"type"},{"doc":"The Nakagami distribution.","ref":"Chi2fit.Distribution.Nakagami.html","title":"Chi2fit.Distribution.Nakagami","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Nakagami.html#t:t/0","title":"Chi2fit.Distribution.Nakagami.t/0","type":"type"},{"doc":"The normal or Gauss distribution","ref":"Chi2fit.Distribution.Normal.html","title":"Chi2fit.Distribution.Normal","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Normal.html#t:t/0","title":"Chi2fit.Distribution.Normal.t/0","type":"type"},{"doc":"The Poisson distribution. For the implementation, see https://en.wikipedia.org/wiki/Poisson_distribution , 'Generating Poisson-distributed random variables'","ref":"Chi2fit.Distribution.Poisson.html","title":"Chi2fit.Distribution.Poisson","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Poisson.html#t:t/0","title":"Chi2fit.Distribution.Poisson.t/0","type":"type"},{"doc":"The Skew Exponential Power cumulative distribution (Azzalini). Options ` :method ` - the integration method to use , :gauss and :romberg types are supported , see below ` :tolerance ` - re - iterate until the tolerance is reached ( only for :romberg ) ` :points ` - the number of points to use in :gauss method Integration methods ` :gauss ` - n - point Gauss rule , ` :gauss2 ` - n - point Guass rule with tanh transformation , ` :gauss3 ` - n - point Gauss rule with linear transformstion , ` :romberg ` - Romberg integration , ` :romberg2 ` - Romberg integration with tanh transformation , ` :romberg3 ` - Romberg integration with linear transformstion .","ref":"Chi2fit.Distribution.SEP.html","title":"Chi2fit.Distribution.SEP","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.SEP.html#t:t/0","title":"Chi2fit.Distribution.SEP.t/0","type":"type"},{"doc":"Tracy-Widom distribution.","ref":"Chi2fit.Distribution.TracyWidom.html","title":"Chi2fit.Distribution.TracyWidom","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.TracyWidom.html#t:t/0","title":"Chi2fit.Distribution.TracyWidom.t/0","type":"type"},{"doc":"Bimodal distribution.","ref":"Chi2fit.Distribution.TriModal.html","title":"Chi2fit.Distribution.TriModal","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.TriModal.html#t:t/0","title":"Chi2fit.Distribution.TriModal.t/0","type":"type"},{"doc":"Provides the Uniform distribution.","ref":"Chi2fit.Distribution.Uniform.html","title":"Chi2fit.Distribution.Uniform","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Uniform.html#t:t/0","title":"Chi2fit.Distribution.Uniform.t/0","type":"type"},{"doc":"Provides various distributions.","ref":"Chi2fit.Distribution.Utilities.html","title":"Chi2fit.Distribution.Utilities","type":"module"},{"doc":"Guesses what distribution is likely to fit the sample data","ref":"Chi2fit.Distribution.Utilities.html#guess/3","title":"Chi2fit.Distribution.Utilities.guess/3","type":"function"},{"doc":"Returns the model for a name. The kurtosis is the so-called 'excess kurtosis'. Supported disributions: &quot;wald&quot; - The Wald or Inverse Gauss distribution , &quot;weibull&quot; - The Weibull distribution , &quot;exponential&quot; - The exponential distribution , &quot;poisson&quot; - The Poisson distribution , &quot;normal&quot; - The normal or Gaussian distribution , &quot;frechet&quot; - The Fr échet distribution , &quot;nakagami&quot; - The Nakagami distribution , &quot;sep&quot; - The Skewed Exponential Power distribution ( Azzalini ) , &quot;erlang&quot; - The Erlang distribution , &quot;sep0&quot; - The Skewed Exponential Power distribution ( Azzalini ) with location parameter set to zero ( 0 ) , &quot;tw&quot; / &quot;tw1&quot; - The Tracy - Widom distributions TW1 , &quot;tw2&quot; - The Tracy - Widom distributions TW2 , &quot;tw4&quot; - The Tracy - Widom distributions TW4 , &quot;wishart&quot; - The Wishart distribution . Options Available only for the SEP distribution, see 'sepCDF/5'.","ref":"Chi2fit.Distribution.Utilities.html#model/2","title":"Chi2fit.Distribution.Utilities.model/2","type":"function"},{"doc":"Examples iex&gt; ~M(3 4 5) % Distribution.Uniform { pars : [ 3 , 4 , 5 ] } iex&gt; ~M(3 4 5)u % Distribution.Uniform { pars : [ 3 , 4 , 5 ] } iex&gt; ~M()d % Distribution.Dice { mode : :regular } iex&gt; ~M()dgk % Distribution.Dice { mode : :gk4 } iex&gt; ~M(1.2)p % Distribution.Poisson { pars : [ 1.2 ] , period : 1.0 } iex&gt; ~M(1.2 5.4)w % Distribution.Weibull { pars : [ 1.2 , 5.4 ] } iex&gt; ~M(1.2 5.4)wald % Distribution.Wald { pars : [ 1.2 , 5.4 ] }","ref":"Chi2fit.Distribution.Utilities.html#sigil_M/2","title":"Chi2fit.Distribution.Utilities.sigil_M/2","type":"function"},{"doc":"","ref":"Chi2fit.Distribution.Utilities.html#t:model/0","title":"Chi2fit.Distribution.Utilities.model/0","type":"type"},{"doc":"Wald or Inverse Gauss distribution.","ref":"Chi2fit.Distribution.Wald.html","title":"Chi2fit.Distribution.Wald","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Wald.html#t:t/0","title":"Chi2fit.Distribution.Wald.t/0","type":"type"},{"doc":"Weibull distribution.","ref":"Chi2fit.Distribution.Weibull.html","title":"Chi2fit.Distribution.Weibull","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Weibull.html#t:t/0","title":"Chi2fit.Distribution.Weibull.t/0","type":"type"},{"doc":"Wishart distribution.","ref":"Chi2fit.Distribution.Wishart.html","title":"Chi2fit.Distribution.Wishart","type":"module"},{"doc":"","ref":"Chi2fit.Distribution.Wishart.html#t:t/0","title":"Chi2fit.Distribution.Wishart.t/0","type":"type"},{"doc":"Provides Fast Fourier Transform.","ref":"Chi2fit.FFT.html","title":"Chi2fit.FFT","type":"module"},{"doc":"Calculates the discrete Fast Fourier Transform of a list of numbers. Provides a parallel version (see options below). See [1] for details of the algorithm implemented. Options ` :phase ` - Correction factor to use in the weights of the FFT algorithm . Defaults to 1 . ` :nproc ` - Parellel version . Number of processes to use . See [ 2 ] . Defaults to 1 . References [ 1 ] Zie : https :// en . wikipedia . org / wiki / Cooley % E2 % 80 % 93 Tukey_FFT_algorithm [ 2 ] Parallel version of FFT ; see http :// www . webabode . com / articles / Parallel % 20 FFT % 20 implementations . pdf Examples iex&gt; fft [ 4 ] [ { 4.0 , 0.0 } ] iex&gt; fft [ 1 , 2 , 3 , 4 , 5 , 6 ] [ { 21.0 , 0.0 } , { - 3.0000000000000053 , 5.19615242270663 } , { - 3.0000000000000036 , 1.7320508075688736 } , { - 3.0 , 0.0 } , { - 2.9999999999999982 , - 1.7320508075688799 } , { - 2.999999999999991 , - 5.196152422706634 } ]","ref":"Chi2fit.FFT.html#fft/2","title":"Chi2fit.FFT.fft/2","type":"function"},{"doc":"Calculates the inverse FFT. For available options see fft/2 . Examples iex&gt; ifft [ 4.0 ] [ { 4.0 , 0.0 } ] iex&gt; ifft [ 1.0 , 2.0 , 3.0 ] [ { 2.0 , 0.0 } , { - 0.5000000000000003 , - 0.2886751345948125 } , { - 0.4999999999999995 , 0.28867513459481353 } ] iex&gt; [ 1.0 , 5.0 ] |&gt; fft |&gt; ifft [ { 1.0 , - 3.061616997868383e-16 } , { 5.0 , 6.123233995736767e-17 } ]","ref":"Chi2fit.FFT.html#ifft/2","title":"Chi2fit.FFT.ifft/2","type":"function"},{"doc":"Calculates the norm of a complex number or list of complex numbers. Examples iex&gt; normv [ ] [ ] iex&gt; normv { 2 , 3 } 13 iex&gt; normv [ { 2 , 3 } , { 1 , 2 } ] [ 13 , 5 ]","ref":"Chi2fit.FFT.html#normv/1","title":"Chi2fit.FFT.normv/1","type":"function"},{"doc":"A complex number with a real part and an imaginary part.","ref":"Chi2fit.FFT.html#t:complex/0","title":"Chi2fit.FFT.complex/0","type":"opaque"},{"doc":"A real number.","ref":"Chi2fit.FFT.html#t:real/0","title":"Chi2fit.FFT.real/0","type":"opaque"},{"doc":"Implements fitting a distribution function to sample data. It minimizes the liklihood function. Asymmetric Errors To handle asymmetric errors the module provides three ways of determining the contribution to the likelihood function: ` simple ` - value difference of the observable and model divided by the averaged error lower and upper bounds ; ` asimple ` - value difference of the observable and model divided by the difference between upper / lower bound and the observed value depending on whether the model is larger or smaller than the observed value ; ` linear ` - value difference of the observable and model divided by a linear tranformation ( See below ) . 'linear': Linear transformation Linear transformation that: - is continuous in u = 0 , - passes through the point sigma + at u = 1 , - asymptotically reaches 1 - y at u -&gt; infinity - pass through the point - sigma - at u = - 1 , - asymptotically reaches - y at u -&gt; - infinity References [1] See https://arxiv.org/pdf/physics/0401042v1.pdf","ref":"Chi2fit.Fit.html","title":"Chi2fit.Fit","type":"module"},{"doc":"Calculates the Chi-squared function for a list of observables. The observables are given as a list. Each observation has an error associated with it. The errors can be either symmetric or asymmetric. A 'penalties'-function is used to assign penalties and these contribute to the chi-squared function. It may be used to 'forbid' certain parameter, x combinations. Options ` model ` - Required . Determines the contribution to chi - squared taking the asymmetric errors into account . Vaid values are ` :linear ` , ` :simple ` , and ` :asimple ` . See Errors below Errors ` simple ` - Use for asymmetric errors when the sigma + and sigma - are close to each other ` asimple ` - Use for asymmetric errors when y - values are not bound . ` linear ` - Use this model when the y - values ar bound between 0 and 1 . Linear transformation that : - is continuous in u = 0 , - passes through the point sigma + at u = 1 , - asymptotically reaches 1 - y at u -&gt; infinity - pass through the point - sigma - at u = - 1 , - asymptotically reaches - y at u -&gt; - infinity Examples iex&gt; fun = &amp; ( &amp;1 ) ...&gt; chi2 [ { 0 , 3 , 1 } ] , fun 9.0 iex&gt; fun = &amp; ( &amp;1 ) ...&gt; chi2 [ { 0 , 3 , 1 } , { 1 , 7 , 1 } , { 2 , 3 , 1 } ] , fun 46.0 iex&gt; fun = &amp; ( &amp;1 ) ...&gt; chi2 [ { 0 , 3 , 3 } , { 1 , 7 , 1 } , { 2 , 3 , 1 } ] , fun 38.0 iex&gt; fun = &amp; ( &amp;1 - 2 ) ...&gt; chi2 [ { 0 , 3 , 1 } ] , fun 25.0 end","ref":"Chi2fit.Fit.html#chi2/4","title":"Chi2fit.Fit.chi2/4","type":"function"},{"doc":"Fits observables to a known model. Returns the found minimum chi-squared value, covariance matrix, gradient at the minimum, and the corresponding parameter values including error estimates. For a good fit check the following: ` chi2 per degree of freedom ` - this should be about 1 or less , ` gradient ` - at the minimum the gradient should be zero at all directions . For asymmetric errors use the option model equal to linear . Rough chi-squared surfaces or if numerically unstable, use the option smoothing set to true . Arguments ` observables ` - list of measurements including errors , ` model ` - ` { parameters , fun } ` : set of initial parameter values and a function to fit against the measurements Options ` onstep ` - call back function ; it is called with a map with keys ` delta ` , ` chi2 ` , and ` params ` , ` smoothing ` - boolean value indicating whether the chi - squared is smoothened using a Gauss distribution . This is used in case the surface is rough because of numerical instabilities to smoothen the surface , ` model ` - The same values as in ` chi2 / 3 ` and ` chi2 / 4 ` ` grid? ` - Performs a grid search : per step , tries to fit only one parameter and keeps the others fixed ; selects the parameter in a round - robin fashion ` probes ` -- a list of tuples containing the result of the ` chi2probe / 4 ` function . Each tuple contains the chi2 value and parameter list . Defaults to the empty list .","ref":"Chi2fit.Fit.html#chi2fit/4","title":"Chi2fit.Fit.chi2fit/4","type":"function"},{"doc":"Probes the chi-squared surface within a certain range of the parameters. It does so by randomly selecting parameter value combinations and calculate the chi-squared for the list of observations based on the selected parameter values. This routine is used to roughly probe the chi-squared surface and perform more detailed and expensive calculations to precisely determine the minimum by chi2fit/4 . Returns the minimum chi-squared found, the parameter values, and all probes that resulted in chi-squared difference less than 1 with the minimum. The parameter values found in this set correspond with the errors in determining the parameters. Options ` num ` or ` probes ` - the number of points to calculate , ` mark ` - progress indicator : a keyword list with keys ` m ` , ` c ` , ` x ` , and ` * ` ; the value must be a call back function taking zero arguments . These are called when 1000 , 100 , 10 , probes have been done . The value of key ` * ` is called when a new chi - squared minimum has been found , ` smoothing ` - boolean value indicating whether the chi - squared is smoothened using a Gauss distribution . This is used in case the surface is rough because of numerical instabilities to smoothen the surface , ` model ` - See ` chi2 / 3 ` and ` chi2 / 4 `","ref":"Chi2fit.Fit.html#chi2probe/4","title":"Chi2fit.Fit.chi2probe/4","type":"function"},{"doc":"Partitions the data list in segments with similar chi-squared values when fitting the model","ref":"Chi2fit.Fit.html#find_all/2","title":"Chi2fit.Fit.find_all/2","type":"function"},{"doc":"Finds the point in the data where the chi-squared has a jump when fitting the model","ref":"Chi2fit.Fit.html#find_change/2","title":"Chi2fit.Fit.find_change/2","type":"function"},{"doc":"","ref":"Chi2fit.Fit.html#nopenalties/2","title":"Chi2fit.Fit.nopenalties/2","type":"function"},{"doc":"Chi-squared statistic","ref":"Chi2fit.Fit.html#t:chi2/0","title":"Chi2fit.Fit.chi2/0","type":"type"},{"doc":"Tuple holding chi-squared value, covariance matrix, parameter values, and parameter errors at the minimum chi2fit(see chi2fit/4 )","ref":"Chi2fit.Fit.html#t:chi2fit/0","title":"Chi2fit.Fit.chi2fit/0","type":"type"},{"doc":"Result of chi-squared probe (see &amp;chi2probe/4)","ref":"Chi2fit.Fit.html#t:chi2probe/0","title":"Chi2fit.Fit.chi2probe/0","type":"type"},{"doc":"Tuple with chi-squared, parameter values, parameter errors, and list of intermediate fit results (see chi2probe/4 )","ref":"Chi2fit.Fit.html#t:chi2probe_saved/0","title":"Chi2fit.Fit.chi2probe_saved/0","type":"type"},{"doc":"Tuple with chi-squared, parameter values, and parameter errors at the found minimum (see chi2probe/4 )","ref":"Chi2fit.Fit.html#t:chi2probe_simple/0","title":"Chi2fit.Fit.chi2probe_simple/0","type":"type"},{"doc":"Covariance matrix","ref":"Chi2fit.Fit.html#t:cov/0","title":"Chi2fit.Fit.cov/0","type":"type"},{"doc":"Cumulative distribution mapping 'x' and parameters to a float in the range [0,1].","ref":"Chi2fit.Fit.html#t:distribution/0","title":"Chi2fit.Fit.distribution/0","type":"type"},{"doc":"Tuple describing the parameter values and the distribution function.","ref":"Chi2fit.Fit.html#t:model/0","title":"Chi2fit.Fit.model/0","type":"type"},{"doc":"","ref":"Chi2fit.Fit.html#t:observable/0","title":"Chi2fit.Fit.observable/0","type":"type"},{"doc":"Observation with asymmetric bounds 'y1 &lt; y &lt; y2'.","ref":"Chi2fit.Fit.html#t:observable_asym/0","title":"Chi2fit.Fit.observable_asym/0","type":"type"},{"doc":"Observation with symmetric errors 'dy'.","ref":"Chi2fit.Fit.html#t:observable_symm/0","title":"Chi2fit.Fit.observable_symm/0","type":"type"},{"doc":"","ref":"Chi2fit.Fit.html#t:observables/0","title":"Chi2fit.Fit.observables/0","type":"type"},{"doc":"List of parameter ranges","ref":"Chi2fit.Fit.html#t:params/0","title":"Chi2fit.Fit.params/0","type":"type"},{"doc":"Provides various various plots using the Gnuplot package.","ref":"Chi2fit.Gnuplotlib.html","title":"Chi2fit.Gnuplotlib","type":"module"},{"doc":"Captures the output sent by &amp;Port.open/2 and returns it as a binary","ref":"Chi2fit.Gnuplotlib.html#capture/1","title":"Chi2fit.Gnuplotlib.capture/1","type":"function"},{"doc":"Draws a graph of the empirical CDF as steps, the data points with error bars, and the (fitted) function. Options ` :bin ` - the size of the bins to use , ` :plottitle ` - the title of the plot , ` :xrange ` - the range for the x - values to use in the format &#39;[x1:x2]&#39; ` :xrange ` - the range for the y - values to use in the format &#39;[y1:y2]&#39; ` :xlabel ` - the label to use for the x - axis , ` :ylabel ` - the label to use for the y - axis , ` :func ` - the data to use for the CDF curve as a list of ` [ x , y ] ` , ` :title ` - the title to use for the CDF curve . ` :bounds ` - 2 - tuple of functions describing the minimum and maximum error - curves for the CDF","ref":"Chi2fit.Gnuplotlib.html#ecdf/2","title":"Chi2fit.Gnuplotlib.ecdf/2","type":"function"},{"doc":"Draws a histogram of the data. Options ` :bin ` - the size of the bins to use , ` :plottitle ` - the title of the plot , ` :xrange ` - the range for the x - values to use in the format &#39;[x1:x2]&#39; ` :xrange ` - the range for the y - values to use in the format &#39;[y1:y2]&#39; ` :xlabel ` - the label to use for the x - axis , ` :ylabel ` - the label to use for the y - axis .","ref":"Chi2fit.Gnuplotlib.html#histogram/2","title":"Chi2fit.Gnuplotlib.histogram/2","type":"function"},{"doc":"Plots severals graphs in a multi-plot.","ref":"Chi2fit.Gnuplotlib.html#multi/2","title":"Chi2fit.Gnuplotlib.multi/2","type":"function"},{"doc":"Draws a graph of the PDF. Options ` :bin ` - the size of the bins to use , ` :offset ` -- the offset of the bin , ` :plottitle ` - the title of the plot , ` :noerror ` -- no error bars , ` :xrange ` - the range for the x - values to use in the format &#39;[x1:x2]&#39; ` :xrange ` - the range for the y - values to use in the format &#39;[y1:y2]&#39; ` :xlabel ` - the label to use for the x - axis , ` :ylabel ` - the label to use for the y - axis , ` :pdf ` - the data to use for the PDF curve as a list of ` [ x , y ] ` , ` :title ` - the title to use for the PDF curve .","ref":"Chi2fit.Gnuplotlib.html#pdf/2","title":"Chi2fit.Gnuplotlib.pdf/2","type":"function"},{"doc":"","ref":"Chi2fit.Gnuplotlib.html#surface/2","title":"Chi2fit.Gnuplotlib.surface/2","type":"function"},{"doc":"","ref":"Chi2fit.Gnuplotlib.html#t:datapoint/0","title":"Chi2fit.Gnuplotlib.datapoint/0","type":"type"},{"doc":"","ref":"Chi2fit.Math.html","title":"Chi2fit.Math","type":"module"},{"doc":"Calculates the partial derivative of a function and returns the value. Examples The function value at a point : iex&gt; der ( [ 3.0 ] , fn [ x ] -&gt; x * x end ) |&gt; Float . round ( 3 ) 9.0 The first derivative of a function at a point : iex&gt; der ( [ { 3.0 , 1 } ] , fn [ x ] -&gt; x * x end ) |&gt; Float . round ( 3 ) 6.0 The second derivative of a function at a point : iex&gt; der ( [ { 3.0 , 2 } ] , fn [ x ] -&gt; x * x end ) |&gt; Float . round ( 3 ) 2.0 Partial derivatives with respect to two variables : iex&gt; der ( [ { 2.0 , 1 } , { 3.0 , 1 } ] , fn [ x , y ] -&gt; 3 * x * x * y end ) |&gt; Float . round ( 3 ) 12.0","ref":"Chi2fit.Math.html#der/3","title":"Chi2fit.Math.der/3","type":"function"},{"doc":"Numerical integration providing Gauss and Romberg types.","ref":"Chi2fit.Math.html#integrate/5","title":"Chi2fit.Math.integrate/5","type":"function"},{"doc":"Calculates the jacobian of the function at the point x . Examples iex&gt; jacobian ( [ 2.0 , 3.0 ] , fn [ x , y ] -&gt; x * y end ) |&gt; Enum . map ( &amp; Float . round ( &amp;1 ) ) [ 3.0 , 2.0 ]","ref":"Chi2fit.Math.html#jacobian/3","title":"Chi2fit.Math.jacobian/3","type":"function"},{"doc":"Newton-Fourier method for locating roots and returning the interval where the root is located. See [ https://en.wikipedia.org/wiki/Newton%27s_method#Newton.E2.80.93Fourier_method]","ref":"Chi2fit.Math.html#newton/5","title":"Chi2fit.Math.newton/5","type":"function"},{"doc":"Richardson extrapolation.","ref":"Chi2fit.Math.html#richardson/5","title":"Chi2fit.Math.richardson/5","type":"function"},{"doc":"Supported numerical integration methods","ref":"Chi2fit.Math.html#t:method/0","title":"Chi2fit.Math.method/0","type":"type"},{"doc":"This module provides matrix inverse operations and supporting functions. It provides 2 types of matrix norms and an iterative approach to calculating the matrix inverse. The implementation is based on the work [1]. References [1] F. Soleymani, A Rapid Numerical Algorithm to Compute Matrix Inversion, International Journal of Mathematics and Mathematical Sciences, Volume 2012, Article ID 134653, doi:10.1155/2012/134653","ref":"Chi2fit.Matrix.html","title":"Chi2fit.Matrix","type":"module"},{"doc":"Adds two vectors. Examples iex&gt; add [ 1 , 2 ] , [ 3 , 4 ] [ 4 , 6 ] iex&gt; add [ ] , [ ] [ ] iex&gt; add [ 1 ] , [ 5 ] [ 6 ]","ref":"Chi2fit.Matrix.html#add/2","title":"Chi2fit.Matrix.add/2","type":"function"},{"doc":"Calculates the determinant of the matrix.","ref":"Chi2fit.Matrix.html#det/1","title":"Chi2fit.Matrix.det/1","type":"function"},{"doc":"Returns the diagonal elements of the matrix as a vector. Example iex&gt; diagonal [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] , [ 7 , 8 , 9 ] ] [ 1 , 5 , 9 ]","ref":"Chi2fit.Matrix.html#diagonal/1","title":"Chi2fit.Matrix.diagonal/1","type":"function"},{"doc":"Calculates the inner product of two vectors. Examples iex&gt; dotproduct [ 1 , 2 ] , [ 3 , 4 ] 11 iex&gt; dotproduct [ ] , [ ] 0 iex&gt; dotproduct [ 1 , 2 ] , [ ] ** (ArgumentError) Vectors of unequal length iex&gt; dotproduct [ 1 , 2 ] , [ 1 ] ** (ArgumentError) Vectors of unequal length","ref":"Chi2fit.Matrix.html#dotproduct/3","title":"Chi2fit.Matrix.dotproduct/3","type":"function"},{"doc":"Returns a matrix with the supplied vector as its diagonal elements. Examples iex&gt; from_diagonal [ 1 , 5 , 9 ] [ [ 1 , 0 , 0 ] , [ 0 , 5 , 0 ] , [ 0 , 0 , 9 ] ]","ref":"Chi2fit.Matrix.html#from_diagonal/1","title":"Chi2fit.Matrix.from_diagonal/1","type":"function"},{"doc":"Returns the matrix inverse of the argument. Options ` :tolerance ` - Iterate until the ` norm_1 / 1 ` of I - AV is less than this value ` :algorithm ` - Four algorithms are supported : ` :hotelling_bodewig ` ( second order ) , ` :lie ` ( third order ) , ` :krishnamurthy_sen ` ( sixth order ) , and ` :soleymani ` ( seventh order ) ; defaults to ` :lie ` ` :max_iterations ` - Maximum number of iterations to perform ; defaults to 500 ` :range ` - Range of values from - range to + range as a multiple of the unit matrix to try as an estimate of the inverse matric ; defaults to 100 ` :size ` - Number of tries to estimate initial inverse ; defautls to 100 Examples iex&gt; inverse [ [ 3 ] ] { :ok , [ [ 0.3333333333333333 ] ] } iex&gt; inverse [ [ 1 , 2 ] , [ 3 , 4 ] ] { :ok , [ [ - 2.0 , 1.0 ] , [ 1.5 , - 0.5 ] ] } iex&gt; inverse ( [ [ 3 , 2 , 0 ] , [ 0 , 0 , 1 ] , [ 2 , - 2 , 1 ] ] ) |&gt; elem ( 1 ) |&gt; Enum . map ( fn row -&gt; Enum . map ( row , &amp; Float . round ( &amp;1 , 10 ) ) end ) [ [ 0.2 , - 0.2 , 0.2 ] , [ 0.2 , 0.3 , - 0.3 ] , [ 0.0 , 1.0 , 0.0 ] ] iex&gt; inverse ( [ [ 3 , 2 , 0 ] , [ 0 , 0 , 1 ] , [ 2 , - 2 , 1 ] ] , algorithm : :soleymani ) |&gt; elem ( 1 ) |&gt; Enum . map ( fn row -&gt; Enum . map ( row , &amp; Float . round ( &amp;1 , 14 ) ) end ) [ [ 0.2 , - 0.2 , 0.2 ] , [ 0.2 , 0.3 , - 0.3 ] , [ 0.0 , 1.0 , 0.0 ] ] iex&gt; inverse ( [ [ 3 , 2 , 0 ] , [ 0 , 0 , 1 ] , [ 2 , - 2 , 1 ] ] , tolerance : 1.0e-15 ) |&gt; elem ( 1 ) |&gt; Enum . map ( fn row -&gt; Enum . map ( row , &amp; Float . round ( &amp;1 , 14 ) ) end ) [ [ 0.2 , - 0.2 , 0.2 ] , [ 0.2 , 0.3 , - 0.3 ] , [ 0.0 , 1.0 , 0.0 ] ] For matrices that have no inverse: iex&gt; try do inverse [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] , [ 7 , 8 , 9 ] ] catch x -&gt; x end :no_inverse","ref":"Chi2fit.Matrix.html#inverse/2","title":"Chi2fit.Matrix.inverse/2","type":"function"},{"doc":"Calculates the norm of the matrix as the sum of the absolutes value of all elements. Example iex&gt; norm [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] , [ 7 , 8 , 9 ] ] 45","ref":"Chi2fit.Matrix.html#norm/1","title":"Chi2fit.Matrix.norm/1","type":"function"},{"doc":"Calculates the norm of the matrix. All absolute values of the elements of each row are summed. The maximum value is returned Example iex&gt; norm_1 [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] , [ 7 , 8 , 9 ] ] 24","ref":"Chi2fit.Matrix.html#norm_1/1","title":"Chi2fit.Matrix.norm_1/1","type":"function"},{"doc":"Calculates the norm of the matrix as norm_1/1 but over the columns instead of over the rows. Example iex&gt; norm_inf [ [ 1 , 2 , 3 ] , [ 4 , 5 , 6 ] , [ 7 , 8 , 9 ] ] 18","ref":"Chi2fit.Matrix.html#norm_inf/1","title":"Chi2fit.Matrix.norm_inf/1","type":"function"},{"doc":"Subtracts two matrices and returns the result.","ref":"Chi2fit.Matrix.html#subtract/2","title":"Chi2fit.Matrix.subtract/2","type":"function"},{"doc":"Returns the tranpose of the matrix Examples: iex&gt; transpose [ [ 1 ] ] [ [ 1 ] ] iex&gt; transpose [ [ 1 , 2 ] , [ 3 , 4 ] ] [ [ 1 , 3 ] , [ 2 , 4 ] ]","ref":"Chi2fit.Matrix.html#transpose/1","title":"Chi2fit.Matrix.transpose/1","type":"function"},{"doc":"Constructs a unit matrix of size n. All diagonal elements have value 1 and the rest has value 0. Examples iex&gt; unit ( 3 ) [ [ 1 , 0 , 0 ] , [ 0 , 1 , 0 ] , [ 0 , 0 , 1 ] ] iex&gt; unit ( 0 ) ** (ArgumentError) Illegal argument &#39;0&#39; iex&gt; unit - 1 ** (ArgumentError) Illegal argument &#39;-1&#39; iex&gt; unit 1.3 ** (ArgumentError) Illegal argument &#39;1.3&#39;","ref":"Chi2fit.Matrix.html#unit/1","title":"Chi2fit.Matrix.unit/1","type":"function"},{"doc":"A list of vectors (list of lists of numbers)","ref":"Chi2fit.Matrix.html#t:matrix/0","title":"Chi2fit.Matrix.matrix/0","type":"type"},{"doc":"A list of numbers","ref":"Chi2fit.Matrix.html#t:vector/0","title":"Chi2fit.Matrix.vector/0","type":"type"},{"doc":"","ref":"Chi2fit.MonteCarlo.html","title":"Chi2fit.MonteCarlo","type":"module"},{"doc":"Forecasts how many time periods are needed to complete size items Related functions: forecast_duration/2 and forecast_items/2 .","ref":"Chi2fit.MonteCarlo.html#forecast/4","title":"Chi2fit.MonteCarlo.forecast/4","type":"function"},{"doc":"Returns a function for forecasting the duration to complete a number of items. This function is a wrapper for forecast/4 . Arguments ` data ` - either a data set to base the forecasting on , or a function that returns ( random ) numbers ` size ` - the number of items to complete","ref":"Chi2fit.MonteCarlo.html#forecast_duration/2","title":"Chi2fit.MonteCarlo.forecast_duration/2","type":"function"},{"doc":"Returns a function for forecasting the number of completed items in a number periods. This function is a wrapper for forecast/4 . Arguments ` data ` - either a data set to base the forecasting on , or a function that returns ( random ) numbers ` periods ` - the number of periods to forecast the number of completed items for","ref":"Chi2fit.MonteCarlo.html#forecast_items/2","title":"Chi2fit.MonteCarlo.forecast_items/2","type":"function"},{"doc":"Basic Monte Carlo simulation to repeatedly run a simulation multiple times. Options ` :collect_all? ` - If true , collects data from each individual simulation run and returns this an the third element of the result tuple","ref":"Chi2fit.MonteCarlo.html#mc/3","title":"Chi2fit.MonteCarlo.mc/3","type":"function"},{"doc":"","ref":"Chi2fit.MonteCarlo.html#total_mc/4","title":"Chi2fit.MonteCarlo.total_mc/4","type":"function"},{"doc":"Solves roots for linear, quadratic, and cubic equations.","ref":"Chi2fit.Roots.html","title":"Chi2fit.Roots","type":"module"},{"doc":"Returns the real roots of polynoms of order 1, 2 and 3 as a list. Examples Solve ` 2.0 * x + 5.0 = 0 ` iex&gt; solve [ 2.0 , 5.0 ] [ - 2.5 ] iex&gt; solve [ 2.0 , - 14.0 , 24.0 ] [ 4.0 , 3.0 ] iex&gt; solve [ 1.0 , 0.0 , 5.0 , 6.0 ] [ - 0.9999999999999999 ]","ref":"Chi2fit.Roots.html#solve/1","title":"Chi2fit.Roots.solve/1","type":"function"},{"doc":"","ref":"Chi2fit.Statistics.html","title":"Chi2fit.Statistics","type":"module"},{"doc":"Calculates the autocorrelation coefficient of a list of observations. The implementation uses the discrete Fast Fourier Transform to calculate the autocorrelation. For available options see Chi2fit.FFT.fft/2 . Returns a list of the autocorrelation coefficients. Example iex&gt; auto [ 1 , 2 , 3 ] [ 14.0 , 7.999999999999999 , 2.999999999999997 ]","ref":"Chi2fit.Statistics.html#auto/2","title":"Chi2fit.Statistics.auto/2","type":"function"},{"doc":"Calculates the systematic errors for bins due to uncertainty in assigning data to bins. Options ` bin ` - the size of bins to use ( defaults to 1 ) ` iterations ` - the number of iterations to use to estimate the error due to noise ( defatuls to 100 )","ref":"Chi2fit.Statistics.html#binerror/3","title":"Chi2fit.Statistics.binerror/3","type":"function"},{"doc":"Implements bootstrapping procedure as resampling with replacement. It supports saving intermediate results to a file using :dets . Use the options :safe and :filename (see below) Arguments: ` total ` - Total number resamplings to perform ` data ` - The sample data ` fun ` - The function to evaluate ` options ` - A keyword list of options , see below . Options ` :safe ` - Whether to safe intermediate results to a file , so as to support continuation when it is interrupted . Valid values are ` :safe ` and ` :cont ` . ` :filename ` - The filename to use for storing intermediate results","ref":"Chi2fit.Statistics.html#bootstrap/4","title":"Chi2fit.Statistics.bootstrap/4","type":"function"},{"doc":"Converts a CDF function to a list of data points. Example iex&gt; convert_cdf { fn x -&gt; { :math . exp ( - x ) , :math . exp ( - x ) / 16 , :math . exp ( - x ) / 4 } end , { 1 , 4 } } [ { 1 , 0.36787944117144233 , 0.022992465073215146 , 0.09196986029286058 } , { 2 , 0.1353352832366127 , 0.008458455202288294 , 0.033833820809153176 } , { 3 , 0.049787068367863944 , 0.0031116917729914965 , 0.012446767091965986 } , { 4 , 0.01831563888873418 , 0.0011447274305458862 , 0.004578909722183545 } ]","ref":"Chi2fit.Statistics.html#convert_cdf/1","title":"Chi2fit.Statistics.convert_cdf/1","type":"function"},{"doc":"Generates a Cullen &amp; Frey plot for the sample data. The kurtosis returned is the 'excess kurtosis'.","ref":"Chi2fit.Statistics.html#cullen_frey/2","title":"Chi2fit.Statistics.cullen_frey/2","type":"function"},{"doc":"Extracts data point with standard deviation from Cullen &amp; Frey plot data.","ref":"Chi2fit.Statistics.html#cullen_frey_point/1","title":"Chi2fit.Statistics.cullen_frey_point/1","type":"function"},{"doc":"Generates an empirical Cumulative Distribution Function from sample data. Three parameters determine the resulting empirical distribution: algorithm for assigning errors, the size of the bins, a correction for limiting the bounds on the 'y' values When e.g. task effort/duration is modeled, some tasks measured have 0 time. In practice what is actually is meant, is that the task effort is between 0 and 1 hour. This is where binning of the data happens. Specify a size of the bins to control how this is done. A bin size of 1 means that 0 effort will be mapped to 1/2 effort (at the middle of the bin). This also prevents problems when the fited distribution cannot cope with an effort os zero. Supports two ways of assigning errors: Wald score or Wilson score. See [1]. Valie values for the algorithm argument are :wald or :wilson . In the handbook of MCMC [1] a cumulative distribution is constructed. For the largest 'x' value in the sample, the 'y' value is exactly one (1). In combination with the Wald score this gives zero errors on the value '1'. If the resulting distribution is used to fit a curve this may give an infinite contribution to the maximum likelihood function. Use the correction number to have a 'y' value of slightly less than 1 to prevent this from happening. Especially the combination of 0 correction, algorithm :wald , and 'linear' model for handling asymmetric errors gives problems. The algorithm parameter determines how the errors onthe 'y' value are determined. Currently supported values include :wald and :wilson . References [ 1 ] &quot;Handbook of Monte Carlo Methods&quot; by Kroese , Taimre , and Botev , section 8.4 [ 2 ] See https :// en . wikipedia . org / wiki / Cumulative_frequency_analysis [ 3 ] https :// arxiv . org / pdf / 1112.2593 v3 . pdf [ 4 ] See https :// en . wikipedia . org / wiki / Student % 27 s_t - distribution : 90 % confidence == &gt; t = 1.645 for many data points ( &gt; 120 ) 70 % confidence == &gt; t = 1.000","ref":"Chi2fit.Statistics.html#empirical_cdf/4","title":"Chi2fit.Statistics.empirical_cdf/4","type":"function"},{"doc":"Calculates and returns the error associated with a list of observables. Usually these are the result of a Markov Chain Monte Carlo simulation run. The only supported method is the so-called Initial Sequence Method . See section 1.10.2 (Initial sequence method) of [1]. Input is a list of autocorrelation coefficients. This may be the output of auto/2 . References [ 1 ] &#39;Handbook of Markov Chain Monte Carlo&#39;","ref":"Chi2fit.Statistics.html#error/2","title":"Chi2fit.Statistics.error/2","type":"function"},{"doc":"Calculates the empirical CDF from a sample. Convenience function that chains make_histogram/2 and empirical_cdf/3 .","ref":"Chi2fit.Statistics.html#get_cdf/4","title":"Chi2fit.Statistics.get_cdf/4","type":"function"},{"doc":"Converts a list of numbers to frequency data. The data is divided into bins of size binsize and the number of data points inside a bin are counted. A map is returned with the bin's index as a key and as value the number of data points in that bin. The function returns a list of 2-tuples. Each tuple contains the index of the bin and the value of the count of the number of items in the bin. The index of the bins start at 1 in the following way: [0..1) has index 1 (including 0 and excludes 1), [1..2) has index 2, etc. When an offset is used, the bin starting from the offset, i.e. [offset..offset+1) gets index 1. Values less than the offset are gathered in a bin with index 0. Examples iex&gt; make_histogram [ 1 , 2 , 3 ] [ { 2 , 1 } , { 3 , 1 } , { 4 , 1 } ] iex&gt; make_histogram [ 1 , 2 , 3 ] , 1.0 , 0 [ { 2 , 1 } , { 3 , 1 } , { 4 , 1 } ] iex&gt; make_histogram [ 1 , 2 , 3 , 4 , 5 , 6 , 5 , 4 , 3 , 4 , 5 , 6 , 7 , 8 , 9 ] [ { 2 , 1 } , { 3 , 1 } , { 4 , 2 } , { 5 , 3 } , { 6 , 3 } , { 7 , 2 } , { 8 , 1 } , { 9 , 1 } , { 10 , 1 } ] iex&gt; make_histogram [ 1 , 2 , 3 , 4 , 5 , 6 , 5 , 4 , 3 , 4 , 5 , 6 , 7 , 8 , 9 ] , 3 , 1.5 [ { 0 , 1 } , { 1 , 6 } , { 2 , 6 } , { 3 , 2 } ] iex&gt; make_histogram [ 0 , 0 , 0 , 1 , 3 , 4 , 3 , 2 , 6 , 7 ] , 1 [ { 1 , 3 } , { 2 , 1 } , { 3 , 1 } , { 4 , 2 } , { 5 , 1 } , { 7 , 1 } , { 8 , 1 } ] iex&gt; make_histogram [ 0 , 0 , 0 , 1 , 3 , 4 , 3 , 2 , 6 , 7 ] , 1 , 0.5 [ { 0 , 3 } , { 1 , 1 } , { 2 , 1 } , { 3 , 2 } , { 4 , 1 } , { 6 , 1 } , { 7 , 1 } ]","ref":"Chi2fit.Statistics.html#make_histogram/3","title":"Chi2fit.Statistics.make_histogram/3","type":"function"},{"doc":"Calculates the nth moment of the sample. Example iex&gt; moment [ 1 , 2 , 3 , 4 , 5 , 6 ] , 1 3.5","ref":"Chi2fit.Statistics.html#moment/2","title":"Chi2fit.Statistics.moment/2","type":"function"},{"doc":"Calculates the nth centralized moment of the sample. Example iex&gt; momentc [ 1 , 2 , 3 , 4 , 5 , 6 ] , 1 0.0 iex&gt; momentc [ 1 , 2 , 3 , 4 , 5 , 6 ] , 2 2.9166666666666665","ref":"Chi2fit.Statistics.html#momentc/2","title":"Chi2fit.Statistics.momentc/2","type":"function"},{"doc":"Calculates the nth centralized moment of the sample. Example iex&gt; momentc [ 1 , 2 , 3 , 4 , 5 , 6 ] , 2 , 3.5 2.9166666666666665","ref":"Chi2fit.Statistics.html#momentc/3","title":"Chi2fit.Statistics.momentc/3","type":"function"},{"doc":"Calculates the nth normalized moment of the sample. Example iex&gt; momentn [ 1 , 2 , 3 , 4 , 5 , 6 ] , 1 0.0 iex&gt; momentn [ 1 , 2 , 3 , 4 , 5 , 6 ] , 2 1.0 iex&gt; momentn [ 1 , 2 , 3 , 4 , 5 , 6 ] , 4 1.7314285714285718","ref":"Chi2fit.Statistics.html#momentn/2","title":"Chi2fit.Statistics.momentn/2","type":"function"},{"doc":"Calculates the nth normalized moment of the sample. Example iex&gt; momentn [ 1 , 2 , 3 , 4 , 5 , 6 ] , 4 , 3.5 1.7314285714285718","ref":"Chi2fit.Statistics.html#momentn/3","title":"Chi2fit.Statistics.momentn/3","type":"function"},{"doc":"Calculates the nth normalized moment of the sample.","ref":"Chi2fit.Statistics.html#momentn/4","title":"Chi2fit.Statistics.momentn/4","type":"function"},{"doc":"Converts the input so that the result is a Puiseaux diagram, that is a strict convex shape. Examples iex&gt; puiseaux [ 1 ] [ 1 ] iex&gt; puiseaux [ 5 , 3 , 3 , 2 ] [ 5 , 3 , 2.5 , 2 ]","ref":"Chi2fit.Statistics.html#puiseaux/3","title":"Chi2fit.Statistics.puiseaux/3","type":"function"},{"doc":"Resamples the subsequences of numbers contained in the list as determined by analyze/2","ref":"Chi2fit.Statistics.html#resample/2","title":"Chi2fit.Statistics.resample/2","type":"function"},{"doc":"Calculates the test statistic for subexponentiality of a sample. A value close to 0 is a strong indication that the sample shows subexponential behaviour (extremistan), i.e. is fat-tailed.","ref":"Chi2fit.Statistics.html#subexponential_stat/4","title":"Chi2fit.Statistics.subexponential_stat/4","type":"function"},{"doc":"Converts raw data to binned data with (asymmetrical) errors.","ref":"Chi2fit.Statistics.html#to_bins/2","title":"Chi2fit.Statistics.to_bins/2","type":"function"},{"doc":"Algorithm used to assign errors to frequencey data: Wald score and Wilson score.","ref":"Chi2fit.Statistics.html#t:algorithm/0","title":"Chi2fit.Statistics.algorithm/0","type":"type"},{"doc":"Cumulative Distribution Function","ref":"Chi2fit.Statistics.html#t:cdf/0","title":"Chi2fit.Statistics.cdf/0","type":"type"},{"doc":"","ref":"Chi2fit.Statistics.html#t:cullenfrey/0","title":"Chi2fit.Statistics.cullenfrey/0","type":"type"},{"doc":"Binned data with error bounds specified through low and high values","ref":"Chi2fit.Statistics.html#t:ecdf/0","title":"Chi2fit.Statistics.ecdf/0","type":"type"},{"doc":"","ref":"Chi2fit.Statistics.html#t:range/0","title":"Chi2fit.Statistics.range/0","type":"type"},{"doc":"","ref":"Chi2fit.Times.html","title":"Chi2fit.Times","type":"module"},{"doc":"Adjusts the times to working hours and/or work days. Options ` workhours ` - a 2 - tuple containing the starting and ending hours of the work day ( defaults to { 8.0 , 18.0 } ) ` epoch ` - the epoch to which all data elements are relative ( defaults to 1970 - 01 - 01 ) ` saturday ` - number of days since the epoch that corresponds to a Saturday ( defaults to 9 ) ` correct ` - whether to correct the times for working hours and weekdays ; possible values ` :worktime ` , ` :weekday ` , ` :&quot;weekday+worktime&quot; ` ( defaults to ` false ` )","ref":"Chi2fit.Times.html#adjust_times/2","title":"Chi2fit.Times.adjust_times/2","type":"function"},{"doc":"Returns a Stream that generates a stream of dates. Examples iex&gt; intervals ( end : ~D[2019-06-01] ) |&gt; Enum . take ( 4 ) [ ~D[2019-06-01] , ~D[2019-05-16] , ~D[2019-05-01] , ~D[2019-04-16] ] iex&gt; intervals ( end : ~D[2019-06-01] , type : :weekly ) |&gt; Enum . take ( 4 ) [ ~D[2019-06-01] , ~D[2019-05-18] , ~D[2019-05-04] , ~D[2019-04-20] ] iex&gt; intervals ( end : ~D[2019-06-01] , type : :weekly , weeks : 1 ) |&gt; Enum . take ( 4 ) [ ~D[2019-06-01] , ~D[2019-05-25] , ~D[2019-05-18] , ~D[2019-05-11] ] iex&gt; intervals ( end : ~D[2019-06-01] , type : :weekly , weeks : [ 3 , 2 ] ) |&gt; Enum . take ( 4 ) [ ~D[2019-06-01] , ~D[2019-05-11] , ~D[2019-04-27] , ~D[2019-04-13] ]","ref":"Chi2fit.Times.html#intervals/1","title":"Chi2fit.Times.intervals/1","type":"function"},{"doc":"Maps the date to weekdays such that weekends are eliminated; it does so with respect to a given Saturday Example iex&gt; map2weekdays ( 43568.123 , 43566 ) 43566.123 iex&gt; map2weekdays ( 43574.123 , 43566 ) 43571.123","ref":"Chi2fit.Times.html#map2weekdays/2","title":"Chi2fit.Times.map2weekdays/2","type":"function"},{"doc":"Maps the time of a day into the working hour period Scales the resulting part of the day between 0..1. Arguments ` t ` - date and time of day as a float ; the integer part specifies the day and the fractional part the hour of the day ` startofday ` - start of the work day in hours ` endofday ` - end of the working day in hours Example iex&gt; map2workhours ( 43568.1 , 8 , 18 ) 43568.0 iex&gt; map2workhours ( 43568.5 , 8 , 18 ) 43568.4","ref":"Chi2fit.Times.html#map2workhours/3","title":"Chi2fit.Times.map2workhours/3","type":"function"},{"doc":"Counts the number of dates ( datelist ) that is between consecutive dates in intervals and returns the result as a list of numbers.","ref":"Chi2fit.Times.html#throughput/2","title":"Chi2fit.Times.throughput/2","type":"function"},{"doc":"Returns a list of time differences (assumes an ordered list as input) Options ` cutoff ` - time differences below the cutoff are changed to the cutoff value ( defaults to ` 0.01 ` ) ` drop? ` - whether to drop time differences below the cutoff ( defaults to ` false ` )","ref":"Chi2fit.Times.html#time_diff/2","title":"Chi2fit.Times.time_diff/2","type":"function"},{"doc":"Provides various utilities: Bootstrapping Creating Cumulative Distribution Functions / Histograms from sample data Autocorrelation coefficients","ref":"Chi2fit.Utilities.html","title":"Chi2fit.Utilities","type":"module"},{"doc":"Walks a map structure while applying the function fun .","ref":"Chi2fit.Utilities.html#analyze/3","title":"Chi2fit.Utilities.analyze/3","type":"function"},{"doc":"Pretty-prints a nested array-like structure (list or tuple) as a table.","ref":"Chi2fit.Utilities.html#as_table/2","title":"Chi2fit.Utilities.as_table/2","type":"function"},{"doc":"Displays results of the function Chi2fit.Fit.chi2probe/4","ref":"Chi2fit.Utilities.html#display/2","title":"Chi2fit.Utilities.display/2","type":"function"},{"doc":"Displays results of the function Chi2fit.Fit.chi2fit/4","ref":"Chi2fit.Utilities.html#display/5","title":"Chi2fit.Utilities.display/5","type":"function"},{"doc":"Pretty prints subsequences.","ref":"Chi2fit.Utilities.html#display_subsequences/3","title":"Chi2fit.Utilities.display_subsequences/3","type":"function"},{"doc":"Outputs and formats the errors that result from a call to Chi2fit.Fit.chi2/4 Errors are tuples of length 2 and larger: {[min1,max1], [min2,max2], ...} .","ref":"Chi2fit.Utilities.html#puts_errors/2","title":"Chi2fit.Utilities.puts_errors/2","type":"function"},{"doc":"Reads data from a file specified by filename and returns a stream with the data parsed as floats. It expects a single data point on a separate line and removes entries that: are not floats, and smaller than zero (0)","ref":"Chi2fit.Utilities.html#read_data/1","title":"Chi2fit.Utilities.read_data/1","type":"function"},{"doc":"Examples iex&gt; subsequences [ ] [ ] iex&gt; subsequences [ :a , :b ] [ [ :a ] , [ :a , :b ] ] iex&gt; Stream . cycle ( [ 1 , 2 , 3 ] ) |&gt; subsequences |&gt; Enum . take ( 4 ) [ [ 1 ] , [ 1 , 2 ] , [ 1 , 2 , 3 ] , [ 1 , 2 , 3 , 1 ] ]","ref":"Chi2fit.Utilities.html#subsequences/1","title":"Chi2fit.Utilities.subsequences/1","type":"function"},{"doc":"Unzips lists of 1-, 2-, 3-, 4-, 5-, 6-, 7-, and 8-tuples.","ref":"Chi2fit.Utilities.html#unzip/1","title":"Chi2fit.Utilities.unzip/1","type":"function"},{"doc":"Average and standard deviationm (error)","ref":"Chi2fit.Utilities.html#t:avgsd/0","title":"Chi2fit.Utilities.avgsd/0","type":"type"},{"doc":"","ref":"NotebookUnit.Case.html","title":"NotebookUnit.Case","type":"module"},{"doc":"","ref":"NotebookUnit.Case.html#md_headers/1","title":"NotebookUnit.Case.md_headers/1","type":"function"},{"doc":"","ref":"NotebookUnit.Case.html#md_toc/1","title":"NotebookUnit.Case.md_toc/1","type":"function"},{"doc":"","ref":"NotebookUnit.Case.html#nbrun/2","title":"NotebookUnit.Case.nbrun/2","type":"macro"},{"doc":"","ref":"NotebookUnit.Case.html#nbtest/1","title":"NotebookUnit.Case.nbtest/1","type":"macro"},{"doc":"","ref":"Chi2fit.Distribution.FunctionNotSupportedError.html","title":"Chi2fit.Distribution.FunctionNotSupportedError","type":"exception"},{"doc":"","ref":"Chi2fit.Distribution.Utilities.UnsupportedDistributionError.html","title":"Chi2fit.Distribution.Utilities.UnsupportedDistributionError","type":"exception"},{"doc":"","ref":"Chi2fit.Statistics.UnknownSampleErrorAlgorithmError.html","title":"Chi2fit.Statistics.UnknownSampleErrorAlgorithmError","type":"exception"},{"doc":"This notebook is based on Piotr Przetacznik's IElixir . More information on Chi2fit can be found at: Docker image Github Hex.pm What to find in this notebook? Example notebooks Elixir tutorial Chi2fit Package Available functions Help Help on modules Help on functions Additional packages Usage Special atoms Inline images Command history","ref":"readme.html","title":"Basic usage of the Chi2fit package","type":"extras"},{"doc":"A list of the notebooks that are available: README.ipynb - this notebook ;-) Forecasting-empirical-data.ipynb - directly using the empirical data to forecast Forecasting-bootstrapping.ipynb - estimation of the error of the forecast because the data set is limited Forecasting-fit-to-known-distribution.ipynb - description of the empirical data by a known probability distribution and use this to forecast Forecasting-non-equilibrium.ipynb - analysis of changes in delivery rate to choose the most relevant and recent subsequence in the data set Forecasting-multiplot.ipynb - demonstrates the use of multi plots Forecasting-cycle-time.ipynb - illustrates analysis based on cycle time The folder 'data' contains samples to use: team.csv - data set containing less than 900 completion dates A suggested reading order is shown below. alias Graphvix.Graph , as : G g = G . new node : [ shape : &quot;plaintext&quot; ] { _ , v1 } = G . add_vertex g , &quot;README.ipynb&quot; { _ , v2 } = G . add_vertex g , &quot;Forecasting-empirical-data.ipynb&quot; { _ , v3 } = G . add_vertex g , &quot;Forecasting-bootstrapping.ipynb&quot; { _ , v4 } = G . add_vertex g , &quot;Forecasting-fit-to-known-distribution.ipynb&quot; { _ , v5 } = G . add_vertex g , &quot;Forecasting-non-equilibrium.ipynb&quot; { _ , v6 } = G . add_vertex g , &quot;Forecasting-multiplot.ipynb&quot; { _ , v7 } = G . add_vertex g , &quot;Forecasting-cycle-time.ipynb&quot; G . add_edge g , v1 , v2 G . add_edge g , v2 , v3 G . add_edge g , v2 , v4 G . add_edge g , v4 , v5 G . add_edge g , v2 , v6 G . add_edge g , v4 , v7 :&quot;do not show this result in output&quot; G . compile g , &quot;/app/notebooks/images/readme&quot; , :png { :&quot;this is an inline image&quot; , src : &quot;/app/notebooks/images/readme.png&quot; } Several examples are included. Use the menu File -&gt; open to explore which ones are available. Use thse to learn more about how to use Chi2fit or copy these as a basis for your own notes.","ref":"readme.html#example-notebooks","title":"Basic usage of the Chi2fit package - Example notebooks","type":"extras"},{"doc":"The notebooks are based on Jupyter and on the Elixir kernel. Commands and statements are entered using the language Elixir. There are many good tutorials on Elixir. A good starting point is Elixir's home . New to Elixir? An introduction to Elixir can be found here .","ref":"readme.html#elixir-tutorial","title":"Basic usage of the Chi2fit package - Elixir tutorial","type":"extras"},{"doc":"The Chi2fit package consists of the (Elixir) modules: Distribution FFT Fit Matrix Root Utilities And a module for drawing charts using Gnuplot : Gnuplotlib Finally, a contains the module Chi2fit.Cli for command line use outside of notebooks: [Cli](* Cli List of all available modules (see https://stackoverflow.com/questions/41733712/elixir-list-all-modules-in-namespace ): :application . load :chi2fit with { :ok , list } &lt;- :application . get_key ( :chi2fit , :modules ) do list |&gt; Enum . filter ( &amp; &amp;1 |&gt; Module . split |&gt; Enum . take ( 1 ) == ~w|Chi2fit| ) end [ Chi2fit.Cli , Chi2fit.Distribution , Chi2fit.Distribution.UnsupportedDistributionError , Chi2fit.FFT , Chi2fit.Fit , Chi2fit.Matrix , Chi2fit.Roots , Chi2fit.Utilities , Chi2fit.Utilities.UnknownSampleErrorAlgorithmError ]","ref":"readme.html#chi2fit-package","title":"Basic usage of the Chi2fit package - Chi2fit Package","type":"extras"},{"doc":"The functions provided by the modules are visible using the export function: exports Chi2fit.Distribution guess / 1 guess / 2 guess / 3 model / 1 model / 2","ref":"readme.html#available-functions","title":"Basic usage of the Chi2fit package - Available functions","type":"extras"},{"doc":"For all modules and function 'help' is available using the builtin command h . Help on modules h Chi2fit.Fit \e [ 0 m \e [ 7 m \e [ 33 m Chi2fit.Fit \e [ 0 m \e [ 0 m Implements fitting a distribution function to sample data . It minimizes the liklihood function . \e [ 0 m \e [ 33 m ## Asymmetric Errors\e[0m \e [ 0 m To handle asymmetric errors the module provides three ways of determining the contribution to the likelihood function : \e [ 0 m \e [ 36 m ` simple ` - value difference of the observable and model divided by the averaged error lower and upper bounds ; ` asimple ` - value difference of the observable and model divided by the difference between upper / lower bound and the observed value depending on whether the model is larger or smaller than the observed value ; ` linear ` - value difference of the observable and model divided by a linear tranformation ( See below ) . \e [ 0 m \e [ 0 m \e [ 33 m ### &#39;linear&#39;: Linear transformation\e[0m \e [ 0 m Linear transformation that : \e [ 0 m \e [ 36 m - is continuous in u = 0 , - passes through the point sigma + at u = 1 , - asymptotically reaches 1 - y at u -&gt; infinity - pass through the point - sigma - at u = - 1 , - asymptotically reaches - y at u -&gt; - infinity \e [ 0 m \e [ 0 m \e [ 33 m ## References\e[0m \e [ 0 m [ 1 ] See https :// arxiv . org / pdf / physics / 0401042 v1 . pdf \e [ 0 m Help on functions h Chi2fit.Distribution . model \e [ 0 m \e [ 7 m \e [ 33 m def model ( name , options \\\\ [ ] ) \e [ 0 m \e [ 0 m \e [ 36 m @spec \e [ 0 m model ( name :: String . t ( ) , options :: Keyword . t ( ) ) :: any ( ) Returns the model for a name . \e [ 0 m The kurtosis is the so - called &#39;excess kurtosis&#39; . \e [ 0 m Supported disributions : \e [ 0 m \e [ 36 m &quot;wald&quot; - The Wald or Inverse Gauss distribution , &quot;weibull&quot; - The Weibull distribution , &quot;exponential&quot; - The exponential distribution , &quot;poisson&quot; - The Poisson distribution , &quot;normal&quot; - The normal or Gaussian distribution , &quot;fechet&quot; - The Fr échet distribution , &quot;nakagami&quot; - The Nakagami distribution , &quot;sep&quot; - The Skewed Exponential Power distribution ( Azzalini ) , &quot;erlang&quot; - The Erlang distribution , &quot;sep0&quot; - The Skewed Exponential Power distribution ( Azzalini ) with location parameter set to zero ( 0 ) . \e [ 0 m \e [ 0 m \e [ 33 m ## Options\e[0m \e [ 0 m Available only for the SEP distribution , see &#39;sepCDF/5&#39; . \e [ 0 m","ref":"readme.html#help","title":"Basic usage of the Chi2fit package - Help","type":"extras"},{"doc":"The package Chi2fit is provided 'out-of-the-box' with this notebook. Additional packages can be installed from Hex . IElixir provides a mechanism using Boyle . Suppose we want to use the functions provided by Decimal . Code . compiler_options [ ignore_module_conflict : true ] Boyle . mk ( &quot;decimal_env&quot; ) Boyle . list ( ) All dependencies up to date { :ok , [ &quot;decimal_env&quot; ] } Boyle . activate ( &quot;decimal_env&quot; ) Boyle . install ( { :decimal , &quot;~&gt; 1.7&quot; } ) All dependencies up to date Resolving Hex dependencies ... Dependency resolution completed : New : \e [ 32 m decimal 1.7 . 0 \e [ 0 m * Getting decimal ( Hex package ) == &gt; decimal Compiling 1 file ( . ex ) Generated decimal app :ok sqrt2 = Decimal . sqrt ( &quot;2&quot; ) Decimal . to_string ( sqrt2 ) &quot;1.414213562373095048801688724&quot; ctxt = Decimal . get_context ( ) ctxt = % Decimal.Context { ctxt | precision : 50 } Decimal . set_context ctxt :ok sqrt2 = Decimal . sqrt ( &quot;2&quot; ) Decimal . to_string ( sqrt2 ) &quot;1.4142135623730950488016887242096980785696718753769&quot; Boyle . deactivate ( ) :ok","ref":"readme.html#additional-packages","title":"Basic usage of the Chi2fit package - Additional packages","type":"extras"},{"doc":"Function need to be specified using the module name and function name, for example if we want the value of the Erlang CDF we use the function erlangCDF in the module Chi2fit.Distribution : f = Chi2fit.Distribution . model &quot;erlang&quot; , pars : [ 0.5 , 4.3 ] Distribution . cdf ( f ) . ( 0.1 ) 0.6462613084207343 We use an alias to have to type less: alias Chi2fit.Distribution , as : D f = D . model &quot;erlang&quot; , pars : [ 0.5 , 4.3 ] Distribution . cdf ( f ) . ( 0.1 ) 0.6462613084207343 We can rid of the D. alltogether by using import s: import Chi2fit.Distribution f = model &quot;erlang&quot; , pars : [ 0.5 , 4.3 ] Distribution . cdf ( f ) . ( 0.1 ) 0.6462613084207343","ref":"readme.html#usage","title":"Basic usage of the Chi2fit package - Usage","type":"extras"},{"doc":"IElixir provides three atoms that are interpreted by IElixir . What is an atom? In Elixir an atom ia a variable for which its value is its name. For example, the atmo :variable is an atom and has variable as value. The 3 special atoms in IElixir are: :&quot;this is raw html&quot; - the output result of the command is shown as is instead of an Elixir term :&quot;do not show this result in output&quot; - the output of the statement is not shown in the output cell :&quot;this is an inline image&quot; - used for displaying an image in the output cell (see below) In addition to these atoms, the following tuple is interpreted: {:&quot;this is an inline image&quot;, src: path_to_image} - used for displaying an image in the output cell (see below) These are used by returning either one of these as the result of a command.","ref":"readme.html#special-atoms","title":"Basic usage of the Chi2fit package - Special atoms","type":"extras"},{"doc":"The atom :&quot;this is an inline image&quot; indicates that the output of the cell is to be interpreted as a base64 encoded image. An example based on Gnuplot is shown below. Gnuplot . plot ( [ ~w(set terminal pngcairo size 800,200)a , ~w(set output)a , [ :plot , &#39;sin(x)&#39; , :title , &quot;Sine Wave&quot; ] ] ) Gnuplotlib . capture ( ) |&gt; Base . encode64 |&gt; IO . write :&quot;this is an inline image&quot;","ref":"readme.html#inline-images","title":"Basic usage of the Chi2fit package - Inline images","type":"extras"},{"doc":"IElixir supports a simple command history. The results of the last command is stored in the variable ans . :math . sqrt ( 2 ) 1.4142135623730951 ans 1.4142135623730951 The history of the results of previous commands can be accessed using the variable out . i ( out ) \e [ 33 mTerm \e [ 0 m \e [ 22 m %{ 2 =&gt; [ Chi2fit.Cli , Chi2fit.Distribution , Chi2fit.Distribution.UnsupportedDistributionError , Chi2fit.FFT , Chi2fit.Fit , Chi2fit.Matrix , Chi2fit.Roots , Chi2fit.Utilities , Chi2fit.Utilities.UnknownSampleErrorAlgorithmError ] , 6 =&gt; { :ok , [ &quot;decimal_env&quot; ] } , 7 =&gt; :ok , 8 =&gt; &quot;1.414213562373095048801688724&quot; , 9 =&gt; :ok , 10 =&gt; &quot;1.4142135623730950488016887242096980785696718753769&quot; , 11 =&gt; :ok , 12 =&gt; 0.6462613084207343 , 13 =&gt; 0.6462613084207343 , 14 =&gt; 0.6462613084207343 , 16 =&gt; 1.4142135623730951 , 17 =&gt; 1.4142135623730951 } \e [ 0 m \e [ 33 mData type \e [ 0 m \e [ 22 m Map \e [ 0 m \e [ 33 mReference modules \e [ 0 m \e [ 22 m Map \e [ 0 m \e [ 33 mImplemented protocols \e [ 0 m \e [ 22 m Ecto.DataType , Poison.Decoder , Poison.Encoder , IEx.Info , Collectable , Inspect , Enumerable , Timex.Protocol , CSV.Encode \e [ 0 m out [ 10 ] &quot;1.4142135623730950488016887242096980785696718753769&quot;","ref":"readme.html#command-history","title":"Basic usage of the Chi2fit package - Command history","type":"extras"},{"doc":"This notebook describes how to use Chi2Fit for simple forecasting. This is illustrated for a team that takes up work items, exercises their expertise to complete the work. It shows one way for answering the questions: duration - how many iterations does it take to complete a certain number of items? completed items - how many items can be completed in a certain number of iterations? This note shows (a) what data to use, (b) how to read in the data, (c) estimate the average and variation to answer the above questions. The advantages of this approach are: the data (delivery rate or throughput or production rate) needed is easy to obtain, straightforward way to obtain average and variation, relatively small number of data points are needed (15 - 50 at most), the data is empirical and based on what the team delivered in the (recent) past. The disadvantages include: it assumes that the delivery rate of the team is constant over time, gathering of data is slow: every iteration provides an extra data point, it does not take into account errors and uncertainties in the data. Some of the disadvantages are addressed in other notebooks. Related links Troy Magennis has written excellent tooling that supports all of features demonstrated in this note and many more.","ref":"forecasting-empirical-data.html","title":"Forecasting - based on empirical data","type":"extras"},{"doc":"Copy your team's data in In[2] Change any simulation parameters in In[4] Run the simulation to forecast duration Run the simulation to forecast the number of completed item","ref":"forecasting-empirical-data.html#how-to-use-this-notebook","title":"Forecasting - based on empirical data - How to use this notebook","type":"extras"},{"doc":"Set-up Data and simulation set-up Simple forecast using the empirical data Forecast: Duration Forecast: Completed items References","ref":"forecasting-empirical-data.html#table-of-contents","title":"Forecasting - based on empirical data - Table of contents","type":"extras"},{"doc":"alias Chi2fit.Utilities , as : U alias Gnuplotlib , as : P Gnuplotlib","ref":"forecasting-empirical-data.html#set-up","title":"Forecasting - based on empirical data - Set-up","type":"extras"},{"doc":"As an example consider the throughput of completed backlog items. At the end of a fixed time period we count the number of backlog items that a team completes. Partially completed items are excluded from the count. The numbers corresponding to the most recent times are at the head of the list. Team data data = [ 3 , 3 , 4 , 4 , 7 , 5 , 1 , 11 , 5 , 6 , 3 , 6 , 6 , 5 , 4 , 10 , 4 , 5 , 8 , 2 , 4 , 12 , 5 ] [ 3 , 3 , 4 , 4 , 7 , 5 , 1 , 11 , 5 , 6 , 3 , 6 , 6 , 5 , 4 , 10 , 4 , 5 , 8 , 2 , 4 , 12 , 5 ] A visualization of the data using a histogram or frequency chart is shown below. The horizontal axis indicates the number of completed items in an iteration. The vertical axis shows how often a certain throughput occured. P . histogram ( data , plottitle : &quot;Throughput histogram&quot; , xlabel : &quot;Throughput (items per 2 weeks)&quot; , ylabel : &quot;Frequency&quot; , yrange : &#39;[0:7]&#39; ) :&quot;this is an inline image&quot; Simulation settings Other parameters that affect the forecasting are listed below. Please adjust to your needs. # The size of the backlog, e.g. 100 backlog items size = 100 # Number of iterations to use in the Monte Carlo iterations = 1000 # Number of iterations to forecast the number of completed items periods = 6 6","ref":"forecasting-empirical-data.html#data-and-simulation-set-up","title":"Forecasting - based on empirical data - Data and simulation set-up","type":"extras"},{"doc":"Using the (throughput) data we simulate an iteration by randomly drawing a number from the data. We do this repeatedly until the sum of the numbers equals or exceeds the size of the backlog. The number of draws needed to deplete the backlog is the estimate of many iterations it takes to complete all backlog items. We just described 1 simulation or run. If we do this many times we will find a different number of iterations needed to finish all items. This gives an average and variation. A variation on this is to draw a fixed number of times and sum the numbers that have been drawn. The sum is an estimate of the number of items we expect to complete in this many iterations. This procedure is also known as Monte Carlo and was first described in [1] . A gentle introduction to Monte Carlo simulations is given in [2] . Error Due to the uncertainty in the number of completed items per iteration, the simulation runs will give different results. One can calculate the average and variance of the results. The square root of the variance approximates the error in the estimate. Because it originates from the statistical variation in the throughput data, this erroris known as a statistical error . Forecast: Duration Using the histogram data for the throughput we perform a Monte Carlo simulation to get an estimation for the number of iterations needed to deplete the backlog. Since for a large enough number of samples results of a Monte Carlo simulation approximate the normal distribution. This provides a range for the uncertainty of the number of iterations. We express this as a probability using percentages. { avg , sd , all } = U . mc iterations , U . forecast_duration ( data , size ) , collect_all? : true U . display { avg , sd , :+ } 50 % =&gt; 20.0 units 84 % =&gt; 22.0 units 97.5 % =&gt; 24.0 units 99.85 % =&gt; 27.0 units :ok The interpretation is that in 50% of the (simulation) runs all items have been completed with 20 iterations. And in 84% of the runs this took 22 iterations. We expect that in 16% of the times it will take more than 22 iterations to complete all items. P . histogram ( all , plottitle : &quot;Monte Carlo result for duration&quot; , xlabel : &quot;Duration (number of iterations)&quot; , ylabel : &quot;Frequency&quot; , xrange : &#39;[0:30]&#39; ) :&quot;this is an inline image&quot; Forecast: Completed items { avg , sd , all } = U . mc iterations , U . forecast_items ( data , periods ) , collect_all? : true U . display { avg , sd , :- } 50 % =&gt; 33.0 units 84 % =&gt; 26.0 units 97.5 % =&gt; 20.0 units 99.85 % =&gt; 13.0 units :ok Here, the interpretation is that in 50% of the runs 32 work items or more have been completed in 6 iterations. While in 84% of the runs 26 or more work items have been completed. Finally, we expect with near certainty to always complete 13 work items or more. P . histogram ( all , plottitle : &quot;Monte Carlo result for completed items after \#{ periods } iterations&quot; , xlabel : &quot;Completed items (count)&quot; , ylabel : &quot;Frequency&quot; , xrange : &#39;[0:75]&#39; ) :&quot;this is an inline image&quot;","ref":"forecasting-empirical-data.html#simple-forecast-using-the-empirical-data","title":"Forecasting - based on empirical data - Simple forecast using the empirical data","type":"extras"},{"doc":"[1] Metropolis, N.; Ulam, S. (1949). &quot;The Monte Carlo Method&quot;. Journal of the American Statistical Association. 44 (247): 335–341. [2] Kroese, D. P.; Taimre, T.; Botev, Z.I. (2011). Handbook of Monte Carlo Methods. New York: John Wiley &amp; Sons. p. 772. ISBN 978-0-470-17793-8.","ref":"forecasting-empirical-data.html#references","title":"Forecasting - based on empirical data - References","type":"extras"},{"doc":"Fitting data to known distributions use is done using Chi2Fit . This notebook describes how to use Chi2Fit for simple forecasting. This is illustrated for a team that takes up work items, exercises their expertise to complete the work. It shows one way for answering the questions: duration - how many iterations does it take to complete a certain number of items? completed items - how many items can be completed in a certain number of iterations? This note shows (a) what data to use, (b) how to read in the data, (c) assume a Poisson model for the data, and (d) estimate the average and variation to answer the above questions. The advantages of this approach over directly fitting data (as shown in the notebook 'Forecasting-empirical-data') are: the Poisson distribution most often is a reasonable approximation for the team's throughtpu data, using the this assumption provides more strict bounds on the delivery rate parameter, the forecastting contains less variability The disadvantages include: it assumes that the delivery rate of the team is constant over time, it assumes the Poisson model is reasonable enough model to describe the data.","ref":"forecasting-fit-to-known-distribution.html","title":"Forecasting - fit to a known distribution","type":"extras"},{"doc":"Set-up Data and simulation set-up Preparation Forecasting using a Poisson distribution Rate error propagation: Total Monte Carlo References","ref":"forecasting-fit-to-known-distribution.html#table-of-contents","title":"Forecasting - fit to a known distribution - Table of contents","type":"extras"},{"doc":"alias Chi2fit.Distribution , as : D alias Chi2fit.Fit , as : F alias Chi2fit.Matrix , as : M alias Chi2fit.Utilities , as : U alias Gnuplotlib , as : P alias Exboost.Math Exboost.Math","ref":"forecasting-fit-to-known-distribution.html#set-up","title":"Forecasting - fit to a known distribution - Set-up","type":"extras"},{"doc":"As an example consider the throughput of completed backlog items. At the end of a fixed time period we count the number of backlog items that a teram completes. Partially completed items are excluded from the count. data = [ 3 , 3 , 4 , 4 , 7 , 5 , 1 , 11 , 5 , 6 , 3 , 6 , 6 , 5 , 4 , 10 , 4 , 5 , 8 , 2 , 4 , 12 , 5 ] [ 3 , 3 , 4 , 4 , 7 , 5 , 1 , 11 , 5 , 6 , 3 , 6 , 6 , 5 , 4 , 10 , 4 , 5 , 8 , 2 , 4 , 12 , 5 ] P . histogram ( data , plottitle : &quot;Throughput histogram&quot; , xlabel : &quot;Throughput (items per 2 weeks)&quot; , ylabel : &quot;Frequency&quot; , yrange : &#39;[0:7]&#39; ) :&quot;this is an inline image&quot; Other parameters that affect the forecasting are listed below. Please adjust to your needs. # The size of the backlog, e.g. 100 backlog items size = 100 # Number of iterations to use in the Monte Carlo iterations = 1000 # The size of bins for grouping the data binsize = 1 # Number of probes to use in the chi2 fit probes = 10_000 # The range of the parameter to look for a (global) minimum initial = { 1 , 10 } { 1 , 10 }","ref":"forecasting-fit-to-known-distribution.html#data-and-simulation-set-up","title":"Forecasting - fit to a known distribution - Data and simulation set-up","type":"extras"},{"doc":"Next, we convert the throughput data to a histogram. To this end we group the data in bins of size 1 starting at 0. hdata = U . to_bins data , { binsize , 0 } [ { 1 , 0.043478260869565216 , 0.0058447102657877 , 0.13689038224309594 } , { 2 , 0.08695652173913043 , 0.02977628442357071 , 0.1905937209791003 } , { 3 , 0.21739130434782608 , 0.1263699563343216 , 0.33774551477037923 } , { 4 , 0.43478260869565216 , 0.3160946312914347 , 0.5600249434832333 } , { 5 , 0.6521739130434783 , 0.5263221461493021 , 0.7626298741894857 } , { 6 , 0.782608695652174 , 0.6622544852296207 , 0.8736300436656784 } , { 7 , 0.8260869565217391 , 0.709703289667655 , 0.9080712005244068 } , { 8 , 0.8695652173913043 , 0.7585954661422599 , 0.9405937209791002 } , { 10 , 0.9130434782608695 , 0.8094062790208998 , 0.9702237155764294 } , { 11 , 0.9565217391304348 , 0.8631096177569041 , 0.9941552897342123 } , { 12 , 1.0 , 0.9225113769324543 , 1.0 } ] The data returned contains a list of tuples each describing a bin: the end-point of the bin, the proportional number of events for this bin (the total count is normalized to one), the lower value of the error bound, the upper value of the error bound. As can be seen the sizes of the lower and upper bounds are different in value, i.e. they are asymmetrical. The contribution or weight to the likelihood function used in fitting known distributions will de different depending on whether the observed value if larger or smaller than the predicted value. This is specified by using the option :linear (see below). See [3] for details. P . ecdf ( hdata , plottitle : &quot;Empirical CDF&quot; , xlabel : &quot;Throughput (items per 2 weeks)&quot; , ylabel : &quot;Probability&quot; , xrange : &#39;[0:15]&#39; ) :&quot;this is an inline image&quot;","ref":"forecasting-fit-to-known-distribution.html#preparation","title":"Forecasting - fit to a known distribution - Preparation","type":"extras"},{"doc":"Instead of directly using the raw data captured one can also use a known probability distribution. The parameter of the distribution is matched to the data. After matching the parameter value one uses the known distribution to forecast. Here, we will use the Poisson distribution [1]. This basically assumes that the data points are independent of each other. The code below uses basic settings of the commands provided by Chi2Fit . More advanced options can be found at [2]. First a fixed number of random parameter values are tried to get a rough estimate. The option probes equals the number of tries. Furthermore, since we are fitting a probability distribution which has values on the interval [0,1] the errors are asymmetrical. This is specified by the option linear . model = D . model &quot;poisson&quot; options = [ probes : probes , smoothing : false , model : :linear , saved? : true ] result = { _ , parameters , _ , saved } = F . chi2probe hdata , [ initial ] , { Distribution . cdf ( model ) , &amp; F . nopenalties / 2 } , options U . display result Initial guess : chi2 : 3.7680909998944285 pars : [ 5.467701988785316 ] ranges : { [ 5.26279288835782 , 5.687565561629632 ] } :ok The errors reported is the found range of parameter values where the corresponding chi2 values are within 1 of the found minimum value. After roughly locating the minimum we do a more precise (and computationally more expensive) search for the minimum. options = [ { :probes , saved } | options ] result = { _ , cov , parameters , _ } = F . chi2fit hdata , { parameters , Distribution . cdf ( model ) , &amp; F . nopenalties / 2 } , 10 , options U . display ( hdata , model , result , options ) Final : chi2 : 3.7680887442307553 Degrees of freedom : 10 gradient : [ - 4.284788519377549e-9 ] parameters : [ 5.4680263772768605 ] errors : [ 0.21599806132547897 ] ranges : chi2 : 3.7680887442307553 - 4.752487946555217 parameter : 5.26279288835782 - 5.687565561629632 :ok For a (local) minimum the value of the gradient should be very close to zero. P . ecdf ( hdata , plottitle : &quot;Fit of Poisson to CDF&quot; , xlabel : &quot;Throughput (items per 2 weeks)&quot; , ylabel : &quot;Probability&quot; , xrange : &#39;[0:15]&#39; , title : &quot;Poisson&quot; , func : &amp; Distribution . cdf ( model ) . ( &amp;1 , parameters ) ) :&quot;this is an inline image&quot; rate = hd ( parameters ) pdf = fn x -&gt; :math . pow ( rate , x ) * :math . exp ( - rate ) / Math . tgamma ( x + 1 ) end P . pdf ( data , plottitle : &quot;Fit of PDF to Poisson&quot; , xlabel : &quot;Throughput (items per 2 weeks)&quot; , ylabel : &quot;Frequency&quot; , yrange : &#39;[0:0.35]&#39; , pdf : pdf , title : &quot;Poisson&quot; ) :&quot;this is an inline image&quot; Again, using a Monte Carlo simulation we estimate the number of iterations and the range to expect. { avg , sd , all } = U . mc ( iterations , U . forecast_duration ( fn -&gt; Distribution . random ( model ) . ( parameters ) end , size ) , collect_all? : true ) U . display { avg , sd , :+ } 50 % =&gt; 19.0 units 84 % =&gt; 21.0 units 97.5 % =&gt; 23.0 units 99.85 % =&gt; 25.0 units :ok P . histogram ( all , plottitle : &quot;Monte Carlo simulation for duration&quot; , xlabel : &quot;Duration (number of iterations)&quot; , ylabel : &quot;Frequency&quot; , xrange : &#39;[0:30]&#39; ) :&quot;this is an inline image&quot;","ref":"forecasting-fit-to-known-distribution.html#forecasting-using-a-poisson-distribution","title":"Forecasting - fit to a known distribution - Forecasting using a Poisson distribution","type":"extras"},{"doc":"In the results of a Monte Carlo simulation the errors reported and the range of the number of iterations is the statistical error associated with the Monte Carlo simulation. It dopes not take into account the uncertainty of the parameter used in the fitted probability distribution function. In Total Monte Carlo [4] multiple Monte Carlo simulations are done that correspond to the extreme values of the error bounds of the used parameters. The error results is of a different nature than the statistical error from the Monte Carlo simulation. These error reported separately. # Pick up the error in the paramater value param_errors = cov |&gt; M . diagonal |&gt; Enum . map ( fn x -&gt; x |&gt; abs |&gt; :math . sqrt end ) [ sd_rate ] = param_errors { avg_min , _ } = U . mc ( iterations , fn -&gt; U . forecast ( fn -&gt; Distribution . random ( model ) . ( [ rate - sd_rate ] ) end , size ) end ) { avg_max , _ } = U . mc ( iterations , fn -&gt; U . forecast ( fn -&gt; Distribution . random ( model ) . ( [ rate + sd_rate ] ) end , size ) end ) sd_min = avg - avg_max sd_plus = avg_min - avg IO . puts &quot;Number of iterations to complete the backlog:&quot; IO . puts &quot; \#{ Float . round ( avg , 1 ) } (+/- \#{ Float . round ( sd , 1 ) } ) (- \#{ Float . round ( sd_plus , 1 ) } + \#{ Float . round ( sd_min , 1 ) } )&quot; Number of iterations to complete the backlog : 18.8 ( + / - 1.9 ) ( - 0.7 + 0.8 ) :ok The first error is symmetric while the second error reported is asymmetric. Combining the errors We now have estimated two erros which have a different origin: statistical error caused by the nature of the Poisson distribution as determined in Forecasting using a Poisson distribution , and systematic error caused by the error in the deliveray rate in this section Making the assumption that both are Gaussian - which is true for the systematic error but which is false for the systematic error - allows us to combine the two by quadratically addition. sd_avg = ( sd_plus + sd_min ) / 2 total = :math . sqrt sd * sd + sd_avg * sd_avg U . display { avg , total , :+ } 50 % =&gt; 19.0 units 84 % =&gt; 21.0 units 97.5 % =&gt; 23.0 units 99.85 % =&gt; 25.0 units :ok","ref":"forecasting-fit-to-known-distribution.html#rate-error-propagation-total-monte-carlo","title":"Forecasting - fit to a known distribution - Rate error propagation: Total Monte Carlo","type":"extras"},{"doc":"[1] Poisson distribution , https://en.wikipedia.org/wiki/Poisson_distribution/ &lt;br&gt; [2] Chi2Fit , Pieter Rijken, 2018, https://hex.pm/packages/chi2fit &lt;br&gt; [3] Asymmetric errors , Roger Barlow, Manchester University, UK and Stanford University, USA, PHYSTAT2003, SLAC, Stanford, California, September 8-11, 2003, https://www.slac.stanford.edu/econf/C030908/papers/WEMT002.pdf &lt;br&gt; [4] Efficient use of Monte Carlo: uncertainty propagation , D. Rochman et. al., Nuclear Science and Engineering, 2013, ftp://ftp.nrg.eu/pub/www/talys/bib_rochman/fastTMC.pdf","ref":"forecasting-fit-to-known-distribution.html#references","title":"Forecasting - fit to a known distribution - References","type":"extras"},{"doc":"This notebook describes how to use Chi2Fit for simple forecasting. This is illustrated for a team that takes up work items, exercises their expertise to complete the work. It shows one way for answering the questions: duration - how many iterations does it take to complete a certain number of items? completed items - how many items can be completed in a certain number of iterations? This note addresses one type of error introduced by the data set. The data set that is available always has a limited number of elements and represents an incomplete population from the (assumed) true distribution. Boostrapping [3] is a technique to estimate error due to having an incomplete distribution.","ref":"forecasting-bootstrapping.html","title":"Forecasting - bootstrapping","type":"extras"},{"doc":"Set-up Data and simulation set-up Simple forecast using the empirical data Bootstrapping References","ref":"forecasting-bootstrapping.html#table-of-contents","title":"Forecasting - bootstrapping - Table of contents","type":"extras"},{"doc":"alias Chi2fit.Utilities , as : U alias Gnuplotlib , as : P Gnuplotlib","ref":"forecasting-bootstrapping.html#set-up","title":"Forecasting - bootstrapping - Set-up","type":"extras"},{"doc":"As an example consider the throughput of completed backlog items. At the end of a fixed time period we count the number of backlog items that a team completes. Partially completed items are excluded from the count. The numbers corresponding to the most recent times are at the head of the list. data = [ 3 , 3 , 4 , 4 , 7 , 5 , 1 , 11 , 5 , 6 , 3 , 6 , 6 , 5 , 4 , 10 , 4 , 5 , 8 , 2 , 4 , 12 , 5 ] [ 3 , 3 , 4 , 4 , 7 , 5 , 1 , 11 , 5 , 6 , 3 , 6 , 6 , 5 , 4 , 10 , 4 , 5 , 8 , 2 , 4 , 12 , 5 ] Other parameters that affect the forecasting are listed below. Please adjust to your needs. # The size of the backlog, e.g. 100 backlog items size = 100 # Number of iterations to use in the Monte Carlo iterations = 1000 6","ref":"forecasting-bootstrapping.html#data-and-simulation-set-up","title":"Forecasting - bootstrapping - Data and simulation set-up","type":"extras"},{"doc":"Using the (throughput) data we simulate an iteration by randomly drawing a number from the data. We do this repeatedly until the sum of the numbers equals or exceeds the size of the backlog. The number of draws needed to deplete the backlog is the estimate of many iterations it takes to complete all backlog items. We just described 1 simulation or run. If we do this many times we will find a different number of iterations needed to finish all items. This gives an average and variation. This procedure is also known as Monte Carlo and was first described in [1] . A gentle introduction to Monte Carlo simulations is given in [2] . Error Due to the uncertainty in the number of completed items per iteration, the simulation runs will give different results. One can calculate the average and variance of the results. The square root of the variance approximates the error in the estimate. Because it originates from the statistical variation in the throughput data, this erroris known as a statistical error . Duration Using the histogram data for the throughput we perform a Monte Carlo simulation to get an estimation for the number of iterations needed to deplete the backlog. Since for a large enough number of samples results of a Monte Carlo simulation approximate the normal distribution. This provides a range for the uncertainty of the number of iterations. We express this as a probability using percentages. { avg , sd , all } = U . mc iterations , U . forecast_duration ( data , size ) , collect_all? : true U . display { avg , sd , :+ } 50 % =&gt; 20.0 units 84 % =&gt; 22.0 units 97.5 % =&gt; 24.0 units 99.85 % =&gt; 26.0 units :ok The interpretation is that in 50% of the (simulation) runs all items have been completed with 20 iterations. And in 84% of the runs this took 22 iterations. We expect that in 16% of the times it will take more than 22 iterations to complete all items. P . histogram ( all , plottitle : &quot;Monte Carlo result for duration&quot; , xlabel : &quot;Duration (number of iterations)&quot; , ylabel : &quot;Frequency&quot; , xrange : &#39;[0:30]&#39; ) :&quot;this is an inline image&quot;","ref":"forecasting-bootstrapping.html#simple-forecast-using-the-empirical-data","title":"Forecasting - bootstrapping - Simple forecast using the empirical data","type":"extras"},{"doc":"fun = fn dat , _k -&gt; U . mc ( iterations , U . forecast_duration ( dat , size ) ) end boot = U . bootstrap ( 100 , data , fun ) [ { 18.057 , 2.1484298918047053 } , { 20.349 , 1.6177759424592748 } , { 18.225 , 1.9016768915880558 } , { 20.088 , 2.0391802274443536 } , { 21.711 , 2.5352473252130623 } , { 17.193 , 1.8269512856121781 } , { 17.216 , 2.144141786356497 } , { 17.706 , 1.7508752097165556 } , { 17.55 , 2.1277922830953178 } , { 17.007 , 2.3492447722619305 } , { 23.572 , 3.319761437212019 } , { 20.332 , 2.4814866511831135 } , { 18.971 , 1.9349829456612866 } , { 21.252 , 2.079061326656818 } , { 19.864 , 2.629354293357961 } , { 19.419 , 2.6323827609221278 } , { 18.126 , 2.23206720328936 } , { 16.728 , 2.216757993106147 } , { 16.001 , 1.5436965375357927 } , { 19.286 , 2.219054753718351 } , { 15.933 , 2.2078294771109355 } , { 19.733 , 1.926061006302765 } , { 18.191 , 1.6045307725313396 } , { 20.916 , 1.9096973582219747 } , { 19.163 , 2.412142408731281 } , { 18.16 , 2.1039011383617776 } , { 18.878 , 1.724852457458321 } , { 18.99 , 1.7714118662806857 } , { 16.448 , 1.88130167703109 } , { 16.683 , 1.8543222481542827 } , { 18.131 , 2.855142553358771 } , { 20.501 , 2.298695064596435 } , { 18.067 , 1.9966249021786615 } , { 22.284 , 2.377255560515107 } , { 17.287 , 1.8837810382313565 } , { 19.11 , 2.1844678985968184 } , { 16.282 , 1.982038344735043 } , { 14.194 , 1.6572157373136456 } , { 17.461 , 1.8570080775268478 } , { 20.87 , 2.706861651433259 } , { 20.603 , 2.6494133312867563 } , { 20.788 , 2.232275968602459 } , { 19.426 , 2.0441438305559654 } , { 19.877 , 2.3366366854947787 } , { 20.15 , 1.9584432593261454 } , { 18.884 , 2.079553798294249 } , { 18.337 , 2.0874460472069822 } , { 18.281 , 1.8061115690897942 } , { 21.576 , ... } , { ... } , ... ] list = boot |&gt; Enum . map ( &amp; elem ( &amp;1 , 0 ) ) P . histogram ( list , plottitle : &quot;Bootstrap result&quot; , xlabel : &quot;Average duration (number of iterations)&quot; , ylabel : &quot;Frequency&quot; , xrange : &#39;[0:30]&#39; ) :&quot;this is an inline image&quot; # The average of the bootstrap results avg_boot = U . moment ( list , 1 ) # The error (standard deviation) as a result from the bootstrap sd_boot = :math . sqrt U . momentc ( list , 2 , avg_boot ) U . display { avg_boot , sd_boot , :+ } 50 % =&gt; 20.0 units 84 % =&gt; 22.0 units 97.5 % =&gt; 24.0 units 99.85 % =&gt; 25.0 units :ok This error is of a different nature than the statistical error determined above and is known as a systematic error . It is custom to report these separately where the first number between parenthese refers to the statistical error and the second number between brackets refers to the systematic error . duration = 20.0 ( + / - 2.0 ) ( + / - 2.0 ) iterations As an approximation one can (try to) combine the two by quadratically adding them as shown below. Note : Strictly this is not correct because it assumes that both errors are Gaussian (normally) distributed which is in general not true for systematic errors . sd_total = :math . sqrt sd * sd + sd_boot * sd_boot U . display { avg , sd_total , :+ } 50 % =&gt; 20.0 units 84 % =&gt; 23.0 units 97.5 % =&gt; 26.0 units 99.85 % =&gt; 28.0 units :ok","ref":"forecasting-bootstrapping.html#bootstrapping","title":"Forecasting - bootstrapping - Bootstrapping","type":"extras"},{"doc":"[1] Metropolis, N.; Ulam, S. (1949). &quot;The Monte Carlo Method&quot;. Journal of the American Statistical Association. 44 (247): 335–341. [2] Kroese, D. P.; Taimre, T.; Botev, Z.I. (2011). Handbook of Monte Carlo Methods. New York: John Wiley &amp; Sons. p. 772. ISBN 978-0-470-17793-8. [3] Bootstrapping, http://t-redactyl.io/blog/2015/09/a-gentle-introduction-to-bootstrapping.html","ref":"forecasting-bootstrapping.html#references","title":"Forecasting - bootstrapping - References","type":"extras"},{"doc":"Fitting data to known distributions use is done using Chi2Fit . This note is about forecasting in a non-equilibirum situation. It illustrates how this manifests itself and how to identify a (sub)period of equilibrium. The data used in this note exhibits two 'difficulties': it is a sequence of throughput data with a changing delivery rate, the number of data points is much less than the number of categories ($x$-range).","ref":"forecasting-non-equilibrium.html","title":"Backlog Forecasting - non-equilibrium","type":"extras"},{"doc":"Set-up Data and simulation set-up Preparation Simple forecast using the empirical data First attempt to fit the data using a Poisson distribution Second attempt Forecasting using a Poisson distribution Total Monte Carlo References","ref":"forecasting-non-equilibrium.html#table-of-contents","title":"Backlog Forecasting - non-equilibrium - Table of contents","type":"extras"},{"doc":"require Chi2fit.Distribution alias Chi2fit.Distribution , as : D alias Chi2fit.Fit , as : F alias Chi2fit.Matrix , as : M alias Chi2fit.Utilities , as : U alias Gnuplotlib , as : P alias Gnuplot , as : G alias Exboost.Math Exboost.Math","ref":"forecasting-non-equilibrium.html#set-up","title":"Backlog Forecasting - non-equilibrium - Set-up","type":"extras"},{"doc":"As an example consider the throughput of completed backlog items. At the end of a fixed time period we count the number of backlog items that a team completes. Partially completed items are excluded from the count. The following is such a sequence with the count corresponding to the most recent date as the first item. data = [ 53 , 50 , 53 , 48 , 69 , 39 , 12 , 17 , 21 , 15 , 15 , 31 , 62 , 78 , 23 , 17 , 25 , 28 , 38 , 16 ] [ 53 , 50 , 53 , 48 , 69 , 39 , 12 , 17 , 21 , 15 , 15 , 31 , 62 , 78 , 23 , 17 , 25 , 28 , 38 , 16 ] P . histogram ( data , plottitle : &quot;Throughput histogram&quot; , xlabel : &quot;Throughput (items per 2 weeks)&quot; , ylabel : &quot;Frequency&quot; , yrange : &#39;[0:3]&#39; ) :&quot;this is an inline image&quot; Other parameters that affect the forecasting are listed below. Please adjust to your needs. # The size of the backlog, e.g. 100 backlog items size = 1000 # The time period (in days) that the throughput data is collected period = 15 # The size of the bins (number of periods) binsize = 5 # Number of iterations to use in the Monte Carlo iterations = 1000 # Number of probes to use in the chi2 fit probes = 10_000 # The range of the parameter to look for a (global) minimum initial = [ { 1 , 100 } ] [ { 1 , 100 } ]","ref":"forecasting-non-equilibrium.html#data-and-simulation-set-up","title":"Backlog Forecasting - non-equilibrium - Data and simulation set-up","type":"extras"},{"doc":"Next, we convert the throughput data to a histogram. To this end we group the data in bins of size 5 starting at 0. Note . Here, we have grouped the data in bins of size 5. This is a bit of experimentation. A too small bin size will give many categories but with a few events per bin. This results is a large error per bin. On the other hand, a larger bin size provides more events per bin and a relatively smeller error but with less categories and therefore less data points to fit a distribution. hdata = U . to_bins data , { binsize , 0 } [ { 15 , 0.15 , 0.06851192859049528 , 0.27482375992342073 } , { 20 , 0.3 , 0.18768957690362428 , 0.43588026413027636 } , { 25 , 0.45 , 0.3206378385081606 , 0.5851694522985315 } , { 30 , 0.5 , 0.36721150008242087 , 0.6327884999175791 } , { 35 , 0.55 , 0.41483054770146854 , 0.6793621614918394 } , { 40 , 0.65 , 0.513235780746243 , 0.7692135974636096 } , { 50 , 0.75 , 0.6162610054750528 , 0.8539648329961009 } , { 55 , 0.85 , 0.7251762400765793 , 0.9314880714095048 } , { 65 , 0.9 , 0.7827976428762097 , 0.9656975423431892 } , { 70 , 0.95 , 0.8438262671806204 , 0.993275152469804 } , { 80 , 1.0 , 0.9114867522921007 , 1.0 } ] The data returned contains a list of tuples each describing a bin: the end-point of the bin, the proportional number of events for this bin (the total count is normalized to one), the lower value of the error bound, the upper value of the error bound. As can be seen the sizes of the lower and upper bounds are different in value, i.e. they are asymmetrical. The contribution or weight to the likelihood function used in fitting known distributions will de different depending on whether the observed value if larger or smaller than the predicted value. This is specified by using the option :linear (see below). See [3] for details. P . ecdf ( hdata , plottitle : &quot;Empirical CDF&quot; , xlabel : &quot;Throughput (items per 2 weeks)&quot; , ylabel : &quot;Probability&quot; , xrange : &#39;[0:100]&#39; ) :&quot;this is an inline image&quot;","ref":"forecasting-non-equilibrium.html#preparation","title":"Backlog Forecasting - non-equilibrium - Preparation","type":"extras"},{"doc":"Using the histogram data for the throughput we perform a Monte Carlo simulation to get an estimation for the number of iterations needed to deplete the backlog. Since for a large enough number of samples results of a Monte Carlo simulation approximate the normal distribution. This provides a range for the uncertainty of the number of iterations. We express this as a probability using percentages. { avg , sd , all } = U . mc iterations , U . forecast_duration ( data , size ) , collect_all? : true U . display { avg , sd , :+ } 50 % =&gt; 29.0 units 84 % =&gt; 32.0 units 97.5 % =&gt; 35.0 units 99.85 % =&gt; 38.0 units :ok P . histogram ( all , plottitle : &quot;Monte Carlo result for duration&quot; , xlabel : &quot;Duration (number of iterations)&quot; , ylabel : &quot;Frequency&quot; , xrange : &#39;[0:50]&#39; ) :&quot;this is an inline image&quot;","ref":"forecasting-non-equilibrium.html#simple-forecast-using-the-empirical-data","title":"Backlog Forecasting - non-equilibrium - Simple forecast using the empirical data","type":"extras"},{"doc":"Instead of directly using the raw data captured one can also use a known probability distribution. The parameter of the distribution is matched to the data. After matching the parameter value one uses the known distribution to forecast. Here, we will use the Poisson distribution [1]. This basically assumes that the data points are independent of each other. For most teams we expect this to be a more than reasonable choice. model = D . model { &quot;poisson&quot; , period } options = [ probes : probes , smoothing : false , model : :linear , saved? : true ] [ probes : 10000 , smoothing : false , model : :linear , saved? : true ] The code below uses basic settings of the commands provided by Chi2Fit . More advanced options can be found at [2]. First a fixed number of random parameter values are tried to get a rough estimate. The option probes equals the number of tries. Furthermore, since we are fitting a probability distribution which has values on the interval [0,1] the errors are asymmetrical. This is specified by the option linear . result = { _ , _parameters , _ , _saved } = F . chi2probe hdata , initial , { Distribution . cdf ( model ) , &amp; F . nopenalties / 2 } , options U . display result Initial guess : chi2 : 758345.0965191501 pars : [ 2.254093453886412 ] ranges : { [ 2.254093453886412 , 2.254093453886412 ] } :ok The result shows a very high value of the Chi-squared statistic at the minimum. This is a first indication that a Poisson distribution does not describe our team's data very well. This is surprising and not what we would expect. Let's try to figure out what is going on.","ref":"forecasting-non-equilibrium.html#first-attempt-to-fit-the-data-using-a-poisson-distribution","title":"Backlog Forecasting - non-equilibrium - First attempt to fit the data using a Poisson distribution","type":"extras"},{"doc":"To analyse the team's throughput data we start with the most recent throughput data point and each time add a data point until we reach the end. Doing this we form a sequence of data points where at every step the new sequence is one item longer than the previous sequence. For each such formed subsequence we run a fit against the Poisson distribution. The result is shown below. history = 0 .. length ( data ) - 1 |&gt; Stream . map ( fn i -&gt; data |&gt; Enum . slice ( 0 .. i ) |&gt; U . to_bins ( { binsize , 0 } ) |&gt; F . chi2probe ( initial , { Distribution . cdf ( model ) , &amp; F . nopenalties / 2 } , options ) end ) |&gt; Stream . map ( fn { chi , [ par ] , _ , _ } -&gt; { chi , par } end ) |&gt; Enum . with_index ( ) [ { { 5.22492679879685e-32 , 1.0284522902629398 } , 0 } , { { 0.016698928165325228 , 3.193357602619063 } , 1 } , { { 0.17925424050014777 , 3.3327093698375103 } , 2 } , { { 0.1371925890726049 , 3.227335994317402 } , 3 } , { { 0.03614822142852375 , 3.4161876651232097 } , 4 } , { { 0.036653830756370534 , 3.3156535517364043 } , 5 } , { { 25438.226774399176 , 2.2734227329070826 } , 6 } , { { 19636.44683866897 , 2.277665624453298 } , 7 } , { { 15908.033899385036 , 2.2571700976752975 } , 8 } , { { 91727.98400095743 , 2.163352229599032 } , 9 } , { { 171181.3363278373 , 2.1016911870371855 } , 10 } , { { 141683.10647066715 , 2.10535853566199 } , 11 } , { { 558984.1420884329 , 2.204031590029471 } , 12 } , { { 1583887.8648936248 , 2.2464842100447373 } , 13 } , { { 1369698.5584306146 , 2.247520090548594 } , 14 } , { { 1200105.6684319167 , 2.245378526675139 } , 15 } , { { 1057059.5517384184 , 2.246011609551288 } , 16 } , { { 938087.6697502094 , 2.2508155198918325 } , 17 } , { { 838764.1071894465 , 2.246063071438816 } , 18 } , { { 756919.8976929325 , 2.252333613621648 } , 19 } ] history |&gt; Enum . map ( fn { { chi , rate } , index } -&gt; [ index , Float . round ( chi , 2 ) , Float . round ( rate , 1 ) ] end ) |&gt; U . as_table ( { &quot;Index data point&quot; , &quot;Chi-squared&quot; , &quot;Delivery Rate&quot; } ) :&quot;do not show this result in output&quot; Index data point | Chi - squared | Delivery Rate -- -- -- -- -- -- -- -- | -- -- -- -- -- - | -- -- -- -- -- -- - 0 | 0.0 | 1.0 1 | 0.02 | 3.2 2 | 0.18 | 3.3 3 | 0.14 | 3.2 4 | 0.04 | 3.4 5 | 0.04 | 3.3 6 | 25438.23 | 2.3 7 | 19636.45 | 2.3 8 | 15908.03 | 2.3 9 | 91727.98 | 2.2 10 | 171181.34 | 2.1 11 | 141683.11 | 2.1 12 | 558984.14 | 2.2 13 | 1583887.86 | 2.2 14 | 1369698.56 | 2.2 15 | 1200105.67 | 2.2 16 | 1057059.55 | 2.2 17 | 938087.67 | 2.3 18 | 838764.11 | 2.2 19 | 756919.9 | 2.3 Next, we plot the results for each subsequence. We get two sets of data points corresponding to the value of chi-squared at the minimum and the value for the fitted delivery rate. G . plot ( [ ~w(set terminal png)a , ~w(set output)a , ~w(set title &quot;Team Jupiter&quot;)a , ~w|set xlabel &quot;Iterations (15 days)&quot;|a , ~w(set key bottom right)a , [ :set , :yrange , &#39;[0.001:10000000]&#39; ] , ~w(set arrow from 0,0.1 to 5,0.1)a , ~w(set label &quot;rate = 3.3&quot; at 6,0.1)a , ~w(set arrow from 6,80000 to 11,80000)a , ~w(set label &quot;rate = 1.2&quot; at 3.5,200000)a , ~w(set arrow from 12,700000 to 13,700000)a , ~w(set label &quot;rate = 4.4&quot; at 9.5,1400000)a , ~w(set arrow from 14,1500000 to 19,1500000)a , ~w(set label &quot;rate = 3.6&quot; at 17,3000000)a , ~w(set logscale y)a , [ :plot , G . list ( [ ~w|&#39;-&#39; u 1:2 w points ls 1 title &quot;Delivery rate&quot;|a , [ &quot;&quot; , :u , &#39;1:2&#39; , :w , :points , :ls , 3 , :title , &quot;chi minimum&quot; ] ] ) ] ] , [ history |&gt; Enum . map ( fn { { _ , rate } , x } -&gt; [ x , rate ] end ) , history |&gt; Enum . map ( fn { { chi , _ } , x } -&gt; [ x , chi ] end ) ] ) P . capture ( ) |&gt; Base . encode64 |&gt; IO . write :&quot;this is an inline image&quot; The graph above shows the logarithm of the chi-squared at the minimum as the blue stars. This clearly shows jumps at the sixth, ninth, and twelth data points. The same is true for the delivery rate although this is most evident at the sixth data point! This shows that the most probable explanation is that the delivery rate is not constant for the team over time. One of the assumptions for ther Poisson distribution to describe the data is a constant delivery rate [1], i.e. the delivery rate does not change over time. If we take the 5 most recent data points we can fit this with a Poisson distribution. The downside is that we loose many of our data points resulting in a large error on the fitted delivery rate. Automated Luckily, Chi2fit provides a function that automates the finding of the jumps in how well a distribution is able to describe our data. trends = F . find_all ( data , [ { :bin , binsize } , { :fitmodel , model } , { :init , initial } | options ] ) [ { 0.036298739064136686 , [ 3.3105360191533375 ] , &#39;5250E \\&#39; &#39; } , { 0.6734317357994228 , [ 1.1964637990990683 ] , [ 12 , 17 , 21 , 15 , 15 , 31 ] } , { 5.800820523615346e-4 , [ 4.3540473193510625 ] , &#39;&gt;N&#39; } , { 0.04491801200236626 , [ 1.578301449162081 ] , [ 23 , 17 , 25 , 28 , 38 , 16 ] } ] F.find_all returns a list of tuples. Each tuple includes the elements: value of chi-squared at the found minimum, list of parameter values at the minimum, subsequence of data","ref":"forecasting-non-equilibrium.html#analysis","title":"Backlog Forecasting - non-equilibrium - Analysis","type":"extras"},{"doc":"We take a subset of the original data set, namely the most recent 6 data points. # Extract the most recent data sequence from the head of `trends` { _ , _ , data } = hd trends hdata = U . to_bins data , { binsize , 0 } [ { 40 , 0.16666666666666666 , 0.02262494120997527 , 0.45322913427940825 } , { 50 , 0.5 , 0.24185253403145093 , 0.7581474659685491 } , { 55 , 0.8333333333333334 , 0.5467708657205917 , 0.9773750587900247 } , { 70 , 1.0 , 0.7369106554956896 , 1.0 } ]","ref":"forecasting-non-equilibrium.html#second-attempt","title":"Backlog Forecasting - non-equilibrium - Second attempt","type":"extras"},{"doc":"First, run an initial fit to get an estimate of the parameters. result = { _ , parameters , _ , saved } = F . chi2probe hdata , initial , { Distribution . cdf ( model ) , &amp; F . nopenalties / 2 } , options U . display result Initial guess : chi2 : 0.03658634067587007 pars : [ 3.303671412343659 ] ranges : { [ 3.0710423614985243 , 3.5658573339602837 ] } :ok The errors reported is the found range of parameter values where the corresponding chi2 values are within 1 of the found minimum value. After roughly locating the minimum we do a more precise (and computationally more expensive) search for the minimum. options = [ { :probes , saved } | options ] result = { _ , cov , parameters , _ } = F . chi2fit hdata , { parameters , Distribution . cdf ( model ) , &amp; F . nopenalties / 2 } , 100 , options U . display ( hdata , model , result , options ) Final : chi2 : 0.03628574276222343 Degrees of freedom : 3 gradient : [ - 6.2495214917223885e-12 ] parameters : [ 3.309353062586756 ] errors : [ 0.32807215518642774 ] ranges : chi2 : 0.03628574276222343 - 1.0090360306540513 parameter : 3.0710423614985243 - 3.5658573339602837 :ok For a (local) minimum the value of the gradient should be very close to zero which is the case. The value of chi-squared at the minimum is much, much smaller than 1. Usually values below 1 indicate a very good fit. Large errors on the data make it easy to fit a curve resulting in low values for chi-squared. Here, it means that the errors in the data are large. P . ecdf ( hdata , plottitle : &quot;Fit of Poisson to CDF&quot; , xlabel : &quot;Throughput (items per 2 weeks)&quot; , ylabel : &quot;Probability&quot; , xrange : &#39;[0:100]&#39; , title : &quot;Poisson&quot; , func : &amp; Distribution . cdf ( model ) . ( &amp;1 , parameters ) ) :&quot;this is an inline image&quot; rate = hd ( parameters ) pdf = fn x -&gt; :math . exp ( x * :math . log ( rate * period ) - rate * period - Math . lgamma ( x + 1.0 ) ) end P . pdf ( data , plottitle : &quot;Fit of PDF to Poisson&quot; , xlabel : &quot;Throughput (items per 2 weeks)&quot; , ylabel : &quot;Frequency&quot; , yrange : &#39;[0:0.15]&#39; , pdf : pdf , title : &quot;Poisson&quot; , bin : binsize ) :&quot;this is an inline image&quot; Again, using a Monte Carlo simulation we estimate the number of iterations and the range to expect. [ rate ] = parameters { avg , sd , all } = U . mc iterations , fn -&gt; U . forecast ( fn -&gt; Distribution . random ( model ) . ( parameters ) end , size ) end , collect_all? : true U . display { avg , sd , :+ } 50 % =&gt; 21.0 units 84 % =&gt; 22.0 units 97.5 % =&gt; 22.0 units 99.85 % =&gt; 23.0 units :ok P . histogram ( all , plottitle : &quot;Monte Carlo simulation for duration&quot; , xlabel : &quot;Duration (number of iterations)&quot; , ylabel : &quot;Frequency&quot; , xrange : &#39;[0:30]&#39; ) :&quot;this is an inline image&quot;","ref":"forecasting-non-equilibrium.html#forecasting-using-a-poisson-distribution","title":"Backlog Forecasting - non-equilibrium - Forecasting using a Poisson distribution","type":"extras"},{"doc":"In the results of a Monte Carlo simulation the errors reported and the range of the number of iterations is the statistical error associated with the Monte Carlo simulation. It dopes not take into account the uncertainty of the parameter used in the fitted probability distribution function. In Total Monte Carlo [4] multiple Monte Carlo simulations are done that correspond to the extreme values of the error bounds of the used parameters. The error results is of a different nature than the statistical error from the Monte Carlo simulation. These error reported separately. # Pick up the error in the paramater value param_errors = cov |&gt; M . diagonal |&gt; Enum . map ( fn x -&gt; x |&gt; abs |&gt; :math . sqrt end ) [ sd_rate ] = param_errors { avg_min , _ } = U . mc ( iterations , fn -&gt; U . forecast ( fn -&gt; Distribution . random ( model ) . ( [ rate - sd_rate ] ) end , size ) end ) { avg_max , _ } = U . mc ( iterations , fn -&gt; U . forecast ( fn -&gt; Distribution . random ( model ) . ( [ rate + sd_rate ] ) end , size ) end ) sd_min = avg - avg_max sd_plus = avg_min - avg IO . puts &quot;Number of iterations to complete the backlog:&quot; IO . puts &quot; \#{ Float . round ( avg , 1 ) } (+/- \#{ Float . round ( sd , 1 ) } ) (- \#{ Float . round ( sd_plus , 1 ) } + \#{ Float . round ( sd_min , 1 ) } )&quot; Number of iterations to complete the backlog : 20.7 ( + / - 0.7 ) ( - 2.2 + 1.8 ) :ok The first error is symmetric while the second error reported is asymmetric.","ref":"forecasting-non-equilibrium.html#total-monte-carlo","title":"Backlog Forecasting - non-equilibrium - Total Monte Carlo","type":"extras"},{"doc":"[1] Poisson distribution , https://en.wikipedia.org/wiki/Poisson_distribution/ &lt;br&gt; [2] Chi2Fit , Pieter Rijken, 2018, https://hex.pm/packages/chi2fit &lt;br&gt; [3] Asymmetric errors , Roger Barlow, Manchester University, UK and Stanford University, USA, PHYSTAT2003, SLAC, Stanford, California, September 8-11, 2003, https://www.slac.stanford.edu/econf/C030908/papers/WEMT002.pdf &lt;br&gt; [4] Efficient use of Monte Carlo: uncertainty propagation , D. Rochman et. al., Nuclear Science and Engineering, 2013, ftp://ftp.nrg.eu/pub/www/talys/bib_rochman/fastTMC.pdf","ref":"forecasting-non-equilibrium.html#references","title":"Backlog Forecasting - non-equilibrium - References","type":"extras"},{"doc":"Fitting data to known distributions use is done using Chi2Fit . This note contains an example analysis for 6 teams. This note demonstrates how to use the multi-plot feature of GNUplot.","ref":"example-multi-plot.html","title":"Throughput - Multiple Teams - Multi-plot","type":"extras"},{"doc":"import Chi2fit.Gnuplotlib Chi2fit.Gnuplotlib","ref":"example-multi-plot.html#set-up","title":"Throughput - Multiple Teams - Multi-plot - Set-up","type":"extras"},{"doc":"The following shows the sequences for the throughput (number of work items completed per period) for six teams. The most recent period is the first item in the list. Note that fort all teams the global bin size (see above) applies except for teams 5 for which we will use a bin size of 5. all_data = %{ &quot;Team 1&quot; =&gt; [ 69 , 41 , 53 , 41 , 41 , 48 , 69 , 15 , 15 , 12 , 12 , 15 , 31 , 78 , 62 , 16 , 25 , 28 , 25 , 38 , 16 ] , &quot;Team 2&quot; =&gt; [ 50 , 68 , 36 , 50 , 50 , 68 , 36 , 19 , 15 , 23 , 9 , 15 , 3 , 23 , 23 , 9 , 14 , 2 , 9 , 9 , 14 , 19 , 11 , 0 , 1 , 1 , 1 ] , &quot;Team 3&quot; =&gt; [ 55 , 46 , 46 , 70 , 55 , 70 , 91 , 67 , 49 , 7 , 20 , 34 , 68 , 68 , 20 , 31 , 0 , 0 , 0 , 0 , 0 , 4 , 0 , 0 , 0 , 3 ] , &quot;Team 4&quot; =&gt; [ 55 , 47 , 65 , 50 , 50 , 50 , 57 , 44 , 27 , 25 , 14 , 23 , 30 ] , &quot;Team 5&quot; =&gt; [ throughput : [ 11 , 4 , 11 , 3 , 6 , 0 ] , bin : 1 ] , &quot;Team 6&quot; =&gt; [ 70 , 70 , 86 , 116 , 70 , 103 , 103 , 116 , 73 , 28 , 28 , 35 , 26 , 35 , 70 , 32 , 32 , 26 , 60 , 37 , 19 , 37 , 19 , 16 , 10 , 13 , 31 , 37 , 31 , 24 , 16 , 37 , 3 , 2 , 2 , 4 , 2 , 2 ] , } :&quot;do not show this result in output&quot; We will start by showing a histogram of the raw throughput data: multi ( [ histogram ( all_data [ &quot;Team 1&quot; ] , bin : 5 , plottitle : &quot;Team 1 (bi-weekly)&quot; , ylabel : &quot;Frequency&quot; , xrange : &#39;[0:80]&#39; , yrange : &#39;[:5]&#39; , mode : :as_commands ) , histogram ( all_data [ &quot;Team 2&quot; ] , bin : 5 , plottitle : &quot;Team 2 (bi-weekly)&quot; , xrange : &#39;[0:80]&#39; , yrange : &#39;[:10]&#39; , mode : :as_commands ) , histogram ( all_data [ &quot;Team 3&quot; ] , bin : 5 , plottitle : &quot;Team 3 (bi-weekly)&quot; , xrange : &#39;[0:120]&#39; , yrange : &#39;[:10]&#39; , mode : :as_commands ) , histogram ( all_data [ &quot;Team 4&quot; ] , bin : 5 , plottitle : &quot;Team 4 (bi-weekly)&quot; , xlabel : &quot;Throughput&quot; , ylabel : &quot;Frequency&quot; , xrange : &#39;[0:80]&#39; , yrange : &#39;[:5]&#39; , mode : :as_commands ) , histogram ( all_data [ &quot;Team 5&quot; ] [ :throughput ] , bin : 1 , xlabel : &quot;Throughput&quot; , plottitle : &quot;Team 5 (monthly)&quot; , xrange : &#39;[0:30]&#39; , yrange : &#39;[:5]&#39; , mode : :as_commands ) , histogram ( all_data [ &quot;Team 6&quot; ] , bin : 5 , xlabel : &quot;Throughput&quot; , plottitle : &quot;Team 6 (bi-weekly)&quot; , xrange : &#39;[0:160]&#39; , yrange : &#39;[:10]&#39; , mode : :as_commands ) , ] , columns : 3 , title : &quot;Throughput data for 6 teams&quot; , size : &quot;1200,600&quot; ) :&quot;this is an inline image&quot;","ref":"example-multi-plot.html#multi-plots","title":"Throughput - Multiple Teams - Multi-plot - Multi-plots","type":"extras"},{"doc":"Let's first define what Cycle Time means or how it's defined for the purpose of this notebook: Cycle Time : &quot;...the time between two items emerging from a process&quot; This notebook illustrates an analysis and forecasting for data based on Cycle Time as defined above. In particular the following aspects are considered: working days versus calendar days working hours versus 24h batches of deliveries or single items consistency with the 'Delivery Rate' noise in the data due to sloppy/faulty entry dates of the data","ref":"forecasting-cycle-times.html","title":"Forecasting - using Cycle Times","type":"extras"},{"doc":"Set-up Data and simulation set-up Data analysis Empirical CDF Simple forecast using the empirical data Forecasting using an Erlang distribution Finding an appropriate subsequence References","ref":"forecasting-cycle-times.html#table-of-contents","title":"Forecasting - using Cycle Times - Table of contents","type":"extras"},{"doc":"require Chi2fit.Distribution alias Chi2fit.Distribution , as : D alias Chi2fit.Fit , as : F alias Chi2fit.Utilities , as : U alias Gnuplotlib , as : P :&quot;do not show this result in output&quot;","ref":"forecasting-cycle-times.html#set-up","title":"Forecasting - using Cycle Times - Set-up","type":"extras"},{"doc":"The data set ( team.csv ) consists of several hundreds of completed items in the span of 1 year. In this case the data is exported from Jira . Here, we take as a completion date the resolution times. # # Completed items have a resolution date which is in the column &quot;Resolved&quot; # Jira exports time data as shown above. # deliveries = &quot;/app/notebooks/data/team.csv&quot; |&gt; File . stream! |&gt; U . csv_to_list ( &quot;Resolved&quot; , header? : true , format : &quot;{0D}/{Mshort}/{YY} {h24}:{0m}&quot; ) IO . inspect ( deliveries , print : false , limit : 3 ) IO . puts &quot;Number of completed items: \#{ length ( deliveries ) } &quot; :&quot;do not show this result in output&quot; [ ~N[2019-05-13 13:03:00] , ~N[2019-05-13 11:42:00] , ~N[2019-05-13 09:24:00] , ... ] Number of completed items : 879 First, we set some parameters that will be used later on in this notebook. Especially important for analyzing the data, is that we need to make a choice for how to handle: working days vs calendar days, working hours vs 24h, look at batches of deliveries or at single deliveries, decide on the size of a cluster of data for fitting to a known distribution. ## ## Data analysis ## # Working hours: 8AM to 8PM workhours = { 8 , 20 } # Correct for working days and/or working hours (:weekday, :worktime, :&quot;weekday+worktime&quot;) correct = :&quot;weekday+worktime&quot; # Cutoff for minimum amount of time between consecutive deliveries (15/12/60 corresponds to 15 minutes) cutoff = 15 / ( 12 * 60 ) # Size of the bins to group the data (2/24 means a granularity of 2 hours) binsize = 2 / 12 # The noise to add to the delivery times to estimagte the error due to sloppy/faulty administration #noise = D.normal(0.0, 2.0/12) #noise = fn -&gt; 0.0 end # No noise ## ## Forecasting ## # The size of the backlog, e.g. 100 backlog items size = 1000 ## ## Monte Carlo simulations stuff ## # Number of iterations to use in the Monte Carlo iterations = 100 # Number of probes to use in the chi2 fit probes = 50_000 :&quot;do not show this result in output&quot; { startofday , endofday } = workhours hours_in_day = endofday - startofday :&quot;do not show this result in output&quot; # Cycle Times in number of calendar days ctlist = deliveries |&gt; Stream . chunk_every ( 2 , 1 , :discard ) |&gt; Stream . map ( fn [ d1 , d2 ] -&gt; NaiveDateTime . diff ( d1 , d2 ) end ) # Calculate the time difference between two consecutive deliveries in seconds |&gt; Enum . map ( &amp; &amp;1 / 24 / 3600 ) # Convert the number of seconds to number of days IO . inspect ( ctlist , print : false , limit : 3 ) :&quot;do not show this result in output&quot; [ 0.05625 , 0.09583333333333334 , 0.002777777777777778 , ... ] P . histogram ( ctlist , bin : binsize , plottitle : &quot;Cycle Time histogram&quot; , xlabel : &quot;Cycle Time (calendar days)&quot; , ylabel : &quot;Frequency&quot; , xrange : &#39;[0:]&#39; ) :&quot;this is an inline image&quot; The histogram shows some 'strange' humps. It could be due to so-called multi-modal data. Muti-modal means that the data has a 'preference' for certain values (= the humps) and usually corresponds to different types of work. However, it is more likely to becaused by patterns in the data which we may be able to correct for.","ref":"forecasting-cycle-times.html#data-and-simulation-set-up","title":"Forecasting - using Cycle Times - Data and simulation set-up","type":"extras"},{"doc":"On first site there appear to be bumps around Cycle Times of a whole number of days. Second, between 0 and 1 the Cycle Time exhibits a dip. There are two main factors that may be relevant and may explain this observed behaviour: Work hours . Most people have regularised working hours somewhere between 8AM and 18PM depending on how early they start work, Weekdays . People don't work during the weekends, Sloppy administration . What often happens is that work has completed at some time of the day and instead of immediately registering the work as done, this often happens a couple of hours later, or the next day, or even at the end of an iteration (just before reporting). First we will examine the first 2 factors. One way of handling the 3rd factor is to add a random noise to the completion dates and estimate the effect of this. For now, we'll assume no noise. # No noise noise = fn -&gt; 0.0 end # Assume that in practice deliveries never are at exactly the same time. If so, then we&#39;ll further assume that # this is due to &#39;sloppy&#39; administration. When this happens we set the _Cycle Time_ to a certain minimum space # between them (the cutoff) fun = fn dat -&gt; dat # Map the delivery times to numbers: the number of days since the epoch Jan 1st, 1970: |&gt; Stream . map ( &amp; NaiveDateTime . diff ( &amp;1 , ~N[1970-01-01 00:00:00] , :second ) / ( 24 * 3600 ) ) # Adjust the time for working hours: 8AM - 22PM # This maps the period of working hours to the interval 0..1 |&gt; U . adjust_times ( correct : correct , workhours : workhours ) # Apply noise to our data |&gt; Stream . map ( &amp; &amp;1 + noise . ( ) ) # Sort again to get properly ordered completeion dates |&gt; Enum . sort ( &amp; &amp;1 &gt; &amp;2 ) # Calculate time differences with cut-off |&gt; U . time_diff ( cutoff : cutoff ) end :&quot;do not show this result in output&quot; Next, recalculate the Cycle Times with the corrections specified above. This basically switches from calendar days to working days . # Cycle Times in number of days ctlist = deliveries |&gt; fun . ( ) ctlist |&gt; P . histogram ( bin : binsize , plottitle : &quot;Cycle Time histogram&quot; , xlabel : &quot;Cycle Time (calendar days)&quot; , ylabel : &quot;Frequency&quot; , xrange : &#39;[0:]&#39; ) :&quot;this is an inline image&quot; The effect of the corrections is clearly visible in the chart: much more smoothened graph without significant bumps, no small bar to the left of the largest bar; this is caused by the cutoff. We did not take into account public holidays so this could still introduce small bumps but we expect that this effect is 'within' the noise of the data.","ref":"forecasting-cycle-times.html#data-analysis","title":"Forecasting - using Cycle Times - Data analysis","type":"extras"},{"doc":"hdata = ctlist |&gt; U . to_bins ( { binsize , 0 } ) IO . puts &quot; \#{ length ( ctlist ) } Cycle Times reduced to \#{ length ( hdata ) } bins&quot; :&quot;do not show this result in output&quot; 878 Cycle Times reduced to 19 bins The data returned contains a list of tuples each describing a bin: the end-point of the bin, the proportional number of events for this bin (the total count is normalized to one), the lower value of the error bound, the upper value of the error bound. As can be seen the sizes of the lower and upper bounds are different in value, i.e. they are asymmetrical. The contribution or weight to the likelihood function used in fitting known distributions will de different depending on whether the observed value if larger or smaller than the predicted value. This is specified by using the option :linear (see below). See [3] for details. P . ecdf ( hdata , plottitle : &quot;Empirical CDF&quot; , xlabel : &quot;Cycle Time (working days)&quot; , ylabel : &quot;Probability&quot; , xrange : &#39;[0:8]&#39; ) :&quot;this is an inline image&quot;","ref":"forecasting-cycle-times.html#empirical-cdf","title":"Forecasting - using Cycle Times - Empirical CDF","type":"extras"},{"doc":"Using the histogram data for the throughput we perform a Monte Carlo simulation to get an estimation for the number of iterations needed to deplete the backlog. Since for a large enough number of samples results of a Monte Carlo simulation approximate the normal distribution. This provides a range for the uncertainty of the number of iterations. We express this as a probability using percentages. { avg , sd , all } = U . mc ( iterations , U . forecast_items ( ctlist , size ) , collect_all? : true ) U . display { avg , sd , :+ } :&quot;do not show this result in output&quot; 50 % =&gt; 280.0 units 84 % =&gt; 295.0 units 97.5 % =&gt; 309.0 units 99.85 % =&gt; 324.0 units P . histogram ( all , plottitle : &quot;Monte Carlo result for duration after the first item is delivered&quot; , xlabel : &quot;Duration (number of calendar days)&quot; , ylabel : &quot;Frequency&quot; , yrange : &#39;[0:7]&#39; ) :&quot;this is an inline image&quot;","ref":"forecasting-cycle-times.html#simple-forecast-using-the-empirical-data","title":"Forecasting - using Cycle Times - Simple forecast using the empirical data","type":"extras"},{"doc":"Instead of directly using the raw data captured one can also use a known probability distribution. The parameter of the distribution is matched to the data. After matching the parameter value one uses the known distribution to forecast. Here, we will use the Erlang distribution [1]. This basically assumes that the data points are independent of each other. If the distribution of the Delivery Rate is Poisson (see Forecasting using delivery rate ) we expect that Cycle Times follow an Erlang distribution. Fitting an Erlang distribution to the data The data in hdata is based on Cycle Times bewteen single deliveries. Therefore, we expect the Erlang-1 distribution, which basically is the exponential distribution. model = D . model { &quot;erlang&quot; , 1.0 } options = [ model : :linear ] result = F . chi2fit hdata , { [ 2.5 ] , Distribution . cdf ( model ) , &amp; F . nopenalties / 2 } , 50 , model : :linear U . display ( hdata , model , result , options ) Final : chi2 : 1401.4882365558465 Degrees of freedom : 18 gradient : [ 9.660588105311687e-7 ] parameters : [ 2.6456227455943644 ] errors : [ 0.012418260425177135 ] ranges : chi2 : 1401.4882365558465 - 1401.560926799379 parameter : 2.642269187094888 - 2.6456227460279225 :ok The result returned by chi2fit indicates that given the Erlang-1 distribution we're at the most optimal fit (very small gradient) but that it describes the data very badly (Chi-squared statistic of over 180 per degree of freedom). For good fits we expect a Chi-squared statistic around 1 per degree of freedom. Second try: time between batches of 10 deliveries In the first try we have considered single completed items. With the amount of data we have available this may be too fine grained. Some times it helps by smoothing the data and considering larger chunks of deliveries. In this case, let's see what the data looks like in chunks of 10 deliveries. Therefore, we will alter the data to determine the Cycle Times between 10 completed items. We still expect an Erlang distribution and to be more specific, an Erlang-10 distribution since we will be considering batches of 10 deliveries. batch = 10 binsize = 2 / hours_in_day bdel = deliveries |&gt; Stream . chunk_every ( batch , batch , :discard ) |&gt; Stream . map ( &amp; hd &amp;1 ) hdata = bdel |&gt; U . binerror ( fun , bin : binsize , iterations : 1 , correct : correct , workhours : workhours , cutoff : cutoff ) IO . puts &quot; \#{ length ( ctlist ) } Cycle Times reduced to \#{ length ( hdata ) } bins&quot; :&quot;do not show this result in output&quot; 878 Cycle Times reduced to 28 bins P . ecdf ( hdata , plottitle : &quot;Empirical CDF (batches of 10 items)&quot; , xlabel : &quot;Cycle Time (working days)&quot; , ylabel : &quot;Probability&quot; , xrange : &#39;[0:15]&#39; ) :&quot;this is an inline image&quot; The fit below shows that an Erlang-10 distribution does not describe the batched data. model = D . model { &quot;erlang&quot; , batch * 1.0 } result = F . chi2fit hdata , { [ 2.5 ] , Distribution . cdf ( model ) , &amp; F . nopenalties / 2 } , 50 , model : :linear U . display ( hdata , model , result , options ) :&quot;do not show this result in output&quot; Final : chi2 : 3748757.980852812 Degrees of freedom : 27 gradient : [ - 0.17209093639054504 ] parameters : [ 3.5303335362979893 ] errors : [ 1.6454050684689054e-4 ] ranges : chi2 : 3748757.980852812 - 3748757.9808533373 parameter : 3.530333523724308 - 3.530333543331993 Third try: considering only recent data Perhaps not all data is relevant. As a variation we will consider only data after January 1st, 2019. Again, batches of 10 deliveries. recent = deliveries |&gt; Stream . filter ( fn t -&gt; Timex . after? ( t , ~D[2019-01-01] ) end ) |&gt; Stream . chunk_every ( batch , batch , :discard ) |&gt; Stream . map ( &amp; hd &amp;1 ) hdata = recent |&gt; U . binerror ( fun , bin : binsize , iterations : 1 , correct : correct , workhours : workhours , cutoff : cutoff ) IO . puts &quot; \#{ length ( ctlist ) } Cycle Times reduced to \#{ length ( hdata ) } bins&quot; :&quot;do not show this result in output&quot; 878 Cycle Times reduced to 14 bins P . ecdf ( hdata , plottitle : &quot;Empirical CDF (batches of 10, data after 2019/01/01)&quot; , xlabel : &quot;Cycle Time (working days)&quot; , ylabel : &quot;Probability&quot; , xrange : &#39;[0:6]&#39; ) :&quot;this is an inline image&quot; The plot is very different from the one inthe previous section! The error bars are also larger because we have removed data. result = { _ , _cov , [ lambda ] , _ } = F . chi2fit hdata , { [ 2.5 ] , Distribution . cdf ( model ) , &amp; F . nopenalties / 2 } , 50 , model : :linear U . display ( hdata , model , result , options ) :&quot;do not show this result in output&quot; Final : chi2 : 3.2177459269210007 Degrees of freedom : 13 gradient : [ 2.3145064276875778e-10 ] parameters : [ 5.474676255213248 ] errors : [ 0.1105774361037803 ] ranges : chi2 : 3.2177459269210007 - 4.146884248390765 parameter : 5.368366062762177 - 5.559455152955396 Indeed the fit seems to be a very good despite the low number of data points; a Chi-squared value of 0.8 per degree of freedom is good. The parameter (= delivery rate) is $$\\lambda = 5.4 \\pm 0.1 \\,\\,\\textrm{items per work day}$$. P . ecdf ( hdata , plottitle : &quot;Fit of Erlang to CDF&quot; , xlabel : &quot;Cycle Times (working days)&quot; , ylabel : &quot;Probability&quot; , title : &quot;Erlang_{10}&quot; , func : &amp; Distribution . cdf ( D . model { &quot;erlang&quot; , batch * 1.0 } ) . ( &amp;1 , [ lambda ] ) ) :&quot;this is an inline image&quot;","ref":"forecasting-cycle-times.html#forecasting-using-an-erlang-distribution","title":"Forecasting - using Cycle Times - Forecasting using an Erlang distribution","type":"extras"},{"doc":"Instead of manually removing old data from our data set, Chi2fit provides a function for partitioning the data set into longest subsequences that will fit the chosen model. batch = 10 binsize = 2 / hours_in_day options = [ probes : probes , bin : binsize , init : List . duplicate ( { 0.1 , 50.0 } , Distribution . size ( model ) ) , fitmodel : model , model : :linear ] # Find points in the delivery dates that indicate a change in the model. # `find_all` is a lazy function, meaning it does not always traverse the entire data set. # In the example below, it stops after finding 5 jumping points. trends = bdel |&gt; fun . ( ) |&gt; F . find_all ( options ) |&gt; Enum . take ( 5 ) :&quot;do not show this result in output&quot; trends |&gt; Enum . map ( fn { chi , [ rate ] , list } -&gt; { chi , rate , Enum . sum ( list ) , length ( list ) } end ) |&gt; U . as_table ( { &quot;Goodness of fit&quot; , &quot;Delivery rate (items per working day)&quot; , &quot;Duration (work days)&quot; , &quot;Count of items&quot; } ) :&quot;do not show this result in output&quot; Goodness of fit | Delivery rate ( items per working day ) | Duration ( work days ) | Count of items -- -- -- -- -- -- -- -- -- -- - | -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - | -- -- -- -- -- -- -- -- -- -- | -- -- -- -- -- -- -- 8.594041230934275 | 5.303886896160837 | 93.27500000000146 | 48 14.76545944659221 | 2.0047174100246057 | 76.77500000000146 | 14 2.8345609975017316 | 49.99809889595503 | 2.5916666666671517 | 4 2.7331957165626005e-9 | 14.502794215234198 | 2.3958333333284827 | 2 5.617727177877458 | 49.999373598531555 | 4.802777777782467 | 5 # Get the most recent sequence: { _chi , [ lambda ] , list } = hd trends delivery_rate = lambda * batch # items per 2 weeks startdate = Timex . shift ( ~D[2019-05-13] , days : - round ( Enum . sum ( list ) / 5 * 7 ) ) # work days to calendar days IO . puts ~s[The found sequence runs from \#{ Timex . format! startdate , &quot;{Mshort} {D}, {YYYY}&quot; } till \#{ Timex . format! ~D[2019-05-13] , &quot;{Mshort} {D}, {YYYY}&quot; } ] IO . puts &quot;Delivery rate = \#{ Float . round ( delivery_rate , 2 ) } items per 2 weeks&quot; :&quot;do not show this result in output&quot; The found sequence runs from Jan 2 , 2019 till May 13 , 2019 Delivery rate = 53.04 items per 2 weeks Forecasting # The Erlang_1 distribution is equivalent to the Exponential distribution. # We could have also used Erlang_10 and divided size by 10. This gives equivalent results. { avg , sd } = U . mc ( iterations , U . forecast_items ( fn -&gt; Distribution . random ( D . model &quot;exponential&quot; ) . ( [ lambda ] ) end , size ) ) IO . puts &quot;Forecast using the parameter as fit with the Erlang_10 distribution:&quot; U . display { avg , sd , :+ } :&quot;do not show this result in output&quot; Forecast using the parameter as fit with the Erlang_10 distribution : 50 % =&gt; 189.0 units 84 % =&gt; 195.0 units 97.5 % =&gt; 201.0 units 99.85 % =&gt; 207.0 units Or using the empirical data of the subsequence instead of the whole data set: # Remember to divide size by 10 since `list` corresponds to cycle times of batches of 10 { avg , sd } = U . mc ( iterations , U . forecast_items ( list , size / 10 ) ) IO . puts &quot;Forecast directly using the subsequence of the data set:&quot; U . display { avg , sd , :+ } :&quot;do not show this result in output&quot; Forecast directly using the subsequence of the data set : 50 % =&gt; 196.0 units 84 % =&gt; 205.0 units 97.5 % =&gt; 214.0 units 99.85 % =&gt; 223.0 units","ref":"forecasting-cycle-times.html#finding-an-appropriate-subsequence","title":"Forecasting - using Cycle Times - Finding an appropriate subsequence","type":"extras"},{"doc":"[1] Erlang distribution , https://en.wikipedia.org/wiki/Erlang_distribution [2]: Chi2Fit , Pieter Rijken, 2018, https://hex.pm/packages/chi2fit [3]: Asymmetric errors , Roger Barlow, Manchester University, UK and Stanford University, USA, PHYSTAT2003, SLAC, Stanford, California, September 8-11, 2003, https://www.slac.stanford.edu/econf/C030908/papers/WEMT002.pdf [4]: Efficient use of Monte Carlo: uncertainty propagation , D. Rochman et. al., Nuclear Science and Engineering, 2013, ftp://ftp.nrg.eu/pub/www/talys/bib_rochman/fastTMC.pdf","ref":"forecasting-cycle-times.html#references","title":"Forecasting - using Cycle Times - References","type":"extras"}]