sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"}],"id":"api-reference","title":"API Reference"},{"group":"","headers":[{"anchor":"example-notebooks","id":"Example notebooks"},{"anchor":"elixir-tutorial","id":"Elixir tutorial"},{"anchor":"chi2fit-package","id":"Chi2fit Package"},{"anchor":"available-functions","id":"Available functions"},{"anchor":"help","id":"Help"},{"anchor":"additional-packages","id":"Additional packages"},{"anchor":"usage","id":"Usage"},{"anchor":"special-atoms","id":"Special atoms"},{"anchor":"inline-images","id":"Inline images"},{"anchor":"command-history","id":"Command history"}],"id":"readme","title":"Basic usage of the Chi2fit package"},{"group":"","headers":[{"anchor":"how-to-use-this-notebook","id":"How to use this notebook"},{"anchor":"table-of-contents","id":"Table of contents"},{"anchor":"set-up","id":"Set-up"},{"anchor":"data-and-simulation-set-up","id":"Data and simulation set-up"},{"anchor":"simple-forecast-using-the-empirical-data","id":"Simple forecast using the empirical data"},{"anchor":"references","id":"References"}],"id":"forecasting-empirical-data","title":"Forecasting - based on empirical data"},{"group":"","headers":[{"anchor":"table-of-contents","id":"Table of contents"},{"anchor":"set-up","id":"Set-up"},{"anchor":"data-and-simulation-set-up","id":"Data and simulation set-up"},{"anchor":"preparation","id":"Preparation"},{"anchor":"forecasting-using-a-poisson-distribution","id":"Forecasting using a Poisson distribution"},{"anchor":"rate-error-propagation-total-monte-carlo","id":"Rate error propagation: Total Monte Carlo"},{"anchor":"references","id":"References"}],"id":"forecasting-fit-to-known-distribution","title":"Forecasting - fit to a known distribution"},{"group":"","headers":[{"anchor":"table-of-contents","id":"Table of contents"},{"anchor":"set-up","id":"Set-up"},{"anchor":"data-and-simulation-set-up","id":"Data and simulation set-up"},{"anchor":"simple-forecast-using-the-empirical-data","id":"Simple forecast using the empirical data"},{"anchor":"bootstrapping","id":"Bootstrapping"},{"anchor":"references","id":"References"}],"id":"forecasting-bootstrapping","title":"Forecasting - bootstrapping"},{"group":"","headers":[{"anchor":"table-of-contents","id":"Table of contents"},{"anchor":"set-up","id":"Set-up"},{"anchor":"data-and-simulation-set-up","id":"Data and simulation set-up"},{"anchor":"preparation","id":"Preparation"},{"anchor":"simple-forecast-using-the-empirical-data","id":"Simple forecast using the empirical data"},{"anchor":"first-attempt-to-fit-the-data-using-a-poisson-distribution","id":"First attempt to fit the data using a Poisson distribution"},{"anchor":"analysis","id":"Analysis"},{"anchor":"second-attempt","id":"Second attempt"},{"anchor":"forecasting-using-a-poisson-distribution","id":"Forecasting using a Poisson distribution"},{"anchor":"total-monte-carlo","id":"Total Monte Carlo"},{"anchor":"references","id":"References"}],"id":"forecasting-non-equilibrium","title":"Backlog Forecasting - non-equilibrium"},{"group":"","headers":[{"anchor":"set-up","id":"Set-up"},{"anchor":"multi-plots","id":"Multi-plots"}],"id":"example-multi-plot","title":"Throughput - Multiple Teams - Multi-plot"},{"group":"","headers":[{"anchor":"table-of-contents","id":"Table of contents"},{"anchor":"set-up","id":"Set-up"},{"anchor":"data-and-simulation-set-up","id":"Data and simulation set-up"},{"anchor":"data-analysis","id":"Data analysis"},{"anchor":"empirical-cdf","id":"Empirical CDF"},{"anchor":"simple-forecast-using-the-empirical-data","id":"Simple forecast using the empirical data"},{"anchor":"forecasting-using-an-erlang-distribution","id":"Forecasting using an Erlang distribution"},{"anchor":"finding-an-appropriate-subsequence","id":"Finding an appropriate subsequence"},{"anchor":"references","id":"References"}],"id":"forecasting-cycle-times","title":"Forecasting - using Cycle Times"}],"modules":[{"group":"","id":"Chi2fit.CSV","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"csv_to_list/3","id":"csv_to_list/3"}]}],"sections":[],"title":"Chi2fit.CSV"},{"group":"","id":"Chi2fit.Cli","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"main/0","id":"main/0"},{"anchor":"main/1","id":"main/1"}]}],"sections":[{"anchor":"module-basic-usage-scanning-the-surface","id":"Basic usage: scanning the surface"},{"anchor":"module-input-data-options","id":"Input data options"},{"anchor":"module-distribution-options","id":"Distribution options"},{"anchor":"module-fitting-options","id":"Fitting options"},{"anchor":"module-bootstrapping","id":"Bootstrapping"},{"anchor":"module-output-options","id":"Output options"},{"anchor":"module-general-options","id":"General options"},{"anchor":"module-references","id":"References"}],"title":"Chi2fit.Cli"},{"group":"","id":"Chi2fit.Collector","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"child_spec/1","id":"child_spec/1"},{"anchor":"collect/0","id":"collect/0"},{"anchor":"start_link/0","id":"start_link/0"},{"anchor":"stop/0","id":"stop/0"},{"anchor":"value/0","id":"value/0"}]}],"sections":[],"title":"Chi2fit.Collector"},{"group":"","id":"Chi2fit.Distribution","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"cdf/1","id":"cdf/1"},{"anchor":"kurtosis/1","id":"kurtosis/1"},{"anchor":"name/1","id":"name/1"},{"anchor":"pdf/1","id":"pdf/1"},{"anchor":"random/1","id":"random/1"},{"anchor":"size/1","id":"size/1"},{"anchor":"skewness/1","id":"skewness/1"}]}],"sections":[],"title":"Chi2fit.Distribution"},{"group":"","id":"Chi2fit.Distribution.Bernoulli","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Bernoulli"},{"group":"","id":"Chi2fit.Distribution.BiModal","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.BiModal"},{"group":"","id":"Chi2fit.Distribution.Coin","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Coin"},{"group":"","id":"Chi2fit.Distribution.Constant","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Constant"},{"group":"","id":"Chi2fit.Distribution.Dice","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Dice"},{"group":"","id":"Chi2fit.Distribution.Erlang","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Erlang"},{"group":"","id":"Chi2fit.Distribution.Exponential","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Exponential"},{"group":"","id":"Chi2fit.Distribution.Frechet","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Frechet"},{"group":"","id":"Chi2fit.Distribution.MultiModal","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"weights/1","id":"weights/1"}]}],"sections":[],"title":"Chi2fit.Distribution.MultiModal"},{"group":"","id":"Chi2fit.Distribution.Nakagami","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Nakagami"},{"group":"","id":"Chi2fit.Distribution.Normal","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Normal"},{"group":"","id":"Chi2fit.Distribution.Poisson","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Poisson"},{"group":"","id":"Chi2fit.Distribution.SEP","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[{"anchor":"module-options","id":"Options"},{"anchor":"module-integration-methods","id":"Integration methods"}],"title":"Chi2fit.Distribution.SEP"},{"group":"","id":"Chi2fit.Distribution.TracyWidom","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.TracyWidom"},{"group":"","id":"Chi2fit.Distribution.TriModal","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.TriModal"},{"group":"","id":"Chi2fit.Distribution.Uniform","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Uniform"},{"group":"","id":"Chi2fit.Distribution.Utilities","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:model/0","id":"model/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"guess/3","id":"guess/3"},{"anchor":"model/2","id":"model/2"},{"anchor":"sigil_M/2","id":"sigil_M/2"}]}],"sections":[],"title":"Chi2fit.Distribution.Utilities"},{"group":"","id":"Chi2fit.Distribution.Wald","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Wald"},{"group":"","id":"Chi2fit.Distribution.Weibull","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Weibull"},{"group":"","id":"Chi2fit.Distribution.Wishart","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"Chi2fit.Distribution.Wishart"},{"group":"","id":"Chi2fit.FFT","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:complex/0","id":"complex/0"},{"anchor":"t:real/0","id":"real/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"fft/2","id":"fft/2"},{"anchor":"ifft/2","id":"ifft/2"},{"anchor":"normv/1","id":"normv/1"}]}],"sections":[],"title":"Chi2fit.FFT"},{"group":"","id":"Chi2fit.Fit","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:chi2/0","id":"chi2/0"},{"anchor":"t:chi2fit/0","id":"chi2fit/0"},{"anchor":"t:chi2probe/0","id":"chi2probe/0"},{"anchor":"t:chi2probe_saved/0","id":"chi2probe_saved/0"},{"anchor":"t:chi2probe_simple/0","id":"chi2probe_simple/0"},{"anchor":"t:cov/0","id":"cov/0"},{"anchor":"t:distribution/0","id":"distribution/0"},{"anchor":"t:model/0","id":"model/0"},{"anchor":"t:observable/0","id":"observable/0"},{"anchor":"t:observable_asym/0","id":"observable_asym/0"},{"anchor":"t:observable_symm/0","id":"observable_symm/0"},{"anchor":"t:observables/0","id":"observables/0"},{"anchor":"t:params/0","id":"params/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"chi2/4","id":"chi2/4"},{"anchor":"chi2fit/4","id":"chi2fit/4"},{"anchor":"chi2probe/4","id":"chi2probe/4"},{"anchor":"find_all/2","id":"find_all/2"},{"anchor":"find_change/2","id":"find_change/2"},{"anchor":"nopenalties/2","id":"nopenalties/2"}]}],"sections":[{"anchor":"module-asymmetric-errors","id":"Asymmetric Errors"},{"anchor":"module-references","id":"References"}],"title":"Chi2fit.Fit"},{"group":"","id":"Chi2fit.Gnuplotlib","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:datapoint/0","id":"datapoint/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"capture/1","id":"capture/1"},{"anchor":"ecdf/2","id":"ecdf/2"},{"anchor":"histogram/2","id":"histogram/2"},{"anchor":"multi/2","id":"multi/2"},{"anchor":"pdf/2","id":"pdf/2"},{"anchor":"surface/2","id":"surface/2"}]}],"sections":[],"title":"Chi2fit.Gnuplotlib"},{"group":"","id":"Chi2fit.Math","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:method/0","id":"method/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"der/3","id":"der/3"},{"anchor":"integrate/5","id":"integrate/5"},{"anchor":"jacobian/3","id":"jacobian/3"},{"anchor":"newton/5","id":"newton/5"},{"anchor":"richardson/5","id":"richardson/5"}]}],"sections":[],"title":"Chi2fit.Math"},{"group":"","id":"Chi2fit.Matrix","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:matrix/0","id":"matrix/0"},{"anchor":"t:vector/0","id":"vector/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"add/2","id":"add/2"},{"anchor":"det/1","id":"det/1"},{"anchor":"diagonal/1","id":"diagonal/1"},{"anchor":"dotproduct/3","id":"dotproduct/3"},{"anchor":"from_diagonal/1","id":"from_diagonal/1"},{"anchor":"inverse/2","id":"inverse/2"},{"anchor":"norm/1","id":"norm/1"},{"anchor":"norm_1/1","id":"norm_1/1"},{"anchor":"norm_inf/1","id":"norm_inf/1"},{"anchor":"subtract/2","id":"subtract/2"},{"anchor":"transpose/1","id":"transpose/1"},{"anchor":"unit/1","id":"unit/1"}]}],"sections":[{"anchor":"module-references","id":"References"}],"title":"Chi2fit.Matrix"},{"group":"","id":"Chi2fit.MonteCarlo","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"forecast/4","id":"forecast/4"},{"anchor":"forecast_duration/2","id":"forecast_duration/2"},{"anchor":"forecast_items/2","id":"forecast_items/2"},{"anchor":"mc/3","id":"mc/3"},{"anchor":"total_mc/4","id":"total_mc/4"}]}],"sections":[],"title":"Chi2fit.MonteCarlo"},{"group":"","id":"Chi2fit.Roots","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"solve/1","id":"solve/1"}]}],"sections":[],"title":"Chi2fit.Roots"},{"group":"","id":"Chi2fit.Statistics","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:algorithm/0","id":"algorithm/0"},{"anchor":"t:cdf/0","id":"cdf/0"},{"anchor":"t:cullenfrey/0","id":"cullenfrey/0"},{"anchor":"t:ecdf/0","id":"ecdf/0"},{"anchor":"t:range/0","id":"range/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"auto/2","id":"auto/2"},{"anchor":"binerror/3","id":"binerror/3"},{"anchor":"bootstrap/4","id":"bootstrap/4"},{"anchor":"convert_cdf/1","id":"convert_cdf/1"},{"anchor":"cullen_frey/2","id":"cullen_frey/2"},{"anchor":"cullen_frey_point/1","id":"cullen_frey_point/1"},{"anchor":"empirical_cdf/4","id":"empirical_cdf/4"},{"anchor":"error/2","id":"error/2"},{"anchor":"get_cdf/4","id":"get_cdf/4"},{"anchor":"make_histogram/3","id":"make_histogram/3"},{"anchor":"moment/2","id":"moment/2"},{"anchor":"momentc/2","id":"momentc/2"},{"anchor":"momentc/3","id":"momentc/3"},{"anchor":"momentn/2","id":"momentn/2"},{"anchor":"momentn/3","id":"momentn/3"},{"anchor":"momentn/4","id":"momentn/4"},{"anchor":"puiseaux/3","id":"puiseaux/3"},{"anchor":"resample/2","id":"resample/2"},{"anchor":"subexponential_stat/4","id":"subexponential_stat/4"},{"anchor":"to_bins/2","id":"to_bins/2"}]}],"sections":[],"title":"Chi2fit.Statistics"},{"group":"","id":"Chi2fit.Times","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"adjust_times/2","id":"adjust_times/2"},{"anchor":"intervals/1","id":"intervals/1"},{"anchor":"map2weekdays/2","id":"map2weekdays/2"},{"anchor":"map2workhours/3","id":"map2workhours/3"},{"anchor":"throughput/2","id":"throughput/2"},{"anchor":"time_diff/2","id":"time_diff/2"}]}],"sections":[],"title":"Chi2fit.Times"},{"group":"","id":"Chi2fit.Utilities","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:avgsd/0","id":"avgsd/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"analyze/3","id":"analyze/3"},{"anchor":"as_table/2","id":"as_table/2"},{"anchor":"display/2","id":"display/2"},{"anchor":"display/5","id":"display/5"},{"anchor":"display_subsequences/3","id":"display_subsequences/3"},{"anchor":"puts_errors/2","id":"puts_errors/2"},{"anchor":"read_data/1","id":"read_data/1"},{"anchor":"subsequences/1","id":"subsequences/1"},{"anchor":"unzip/1","id":"unzip/1"}]}],"sections":[],"title":"Chi2fit.Utilities"},{"group":"","id":"NotebookUnit.Case","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"md_headers/1","id":"md_headers/1"},{"anchor":"md_toc/1","id":"md_toc/1"},{"anchor":"nbrun/2","id":"nbrun/2"},{"anchor":"nbtest/1","id":"nbtest/1"}]}],"sections":[],"title":"NotebookUnit.Case"},{"group":"Exceptions","id":"Chi2fit.Distribution.FunctionNotSupportedError","sections":[],"title":"Chi2fit.Distribution.FunctionNotSupportedError"},{"group":"Exceptions","id":"Chi2fit.Distribution.Utilities.UnsupportedDistributionError","sections":[],"title":"Chi2fit.Distribution.Utilities.UnsupportedDistributionError"},{"group":"Exceptions","id":"Chi2fit.Statistics.UnknownSampleErrorAlgorithmError","sections":[],"title":"Chi2fit.Statistics.UnknownSampleErrorAlgorithmError"}],"tasks":[]}